declare
  v_owner_id number;
  v_table_id number;
begin
  v_table_id := get_table_id('nc_dataClassification');
  
  select max(owner) into v_owner_id from nc_dataclassification;
  update nc_dataclassification set name = 'No data entered', description = 'No data entered' where name = 'no data entered';

  update nc_dataclassification set name = 'Subject declined to answer the question', description = 'Subject declined to answer the question' where name = 'subject decline to answer the question';
  update nc_dataclassification set name = 'Interviewer forgot to ask the question', description = 'Interviewer forgot to ask the question' where name = 'interviewer forgot to ask the question';
  update nc_dataclassification set name = 'Interviewer deferred the question', description = 'Interviewer deferred the question' where name = 'interviewer deferred the question';
  update nc_dataclassification set name = 'Question is excluded from the protocol', description = 'Question is excluded from the protocol' where name = 'question is excluded from the protocol';
  update nc_dataclassification set name = 'Question is not applicable to the subject', description = 'Question is not applicable to the subject' where name = 'question is not applicable to the subject';
  update nc_dataclassification set name = 'Answer is not intelligible', description = 'Answer is not intelligible' where name = 'answer is not intelligible';

insert into nc_dataclassification(TABLEID, UNIQUEID, OWNER, MODTIME, MODUSER, name, description)
values(v_table_id, uid_seq.nextval, v_owner_id, sysdate, v_owner_id, 'Answer is unknown to the informant', 'Answer is unknown to the informant');

insert into nc_dataclassification(TABLEID, UNIQUEID, OWNER, MODTIME, MODUSER, name, description)
values(v_table_id, uid_seq.nextval, v_owner_id, sysdate, v_owner_id, 'Missing Value', 'Missing Value');

 commit;
exception
  when others then
  rollback; 
  dbms_output.put_line('an error occured!');
end;
/
