package clinical.server.dao.oracle;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import clinical.server.vo.Protocolmanip;
import clinical.web.DBUtils;
import clinical.web.exception.ValidationException;

public class ProtocolmanipDAO implements clinical.server.dao.ProtocolmanipDAO {
	/* +++ */
	// Enter your declarations here
	/* +++ */

	public ProtocolmanipDAO() {}

	public void insert(Connection con, Protocolmanip bean) throws Exception {
		PreparedStatement ps = null;
		StringBuffer buf = new StringBuffer(200);

		if (bean == null)
			return;
		try {
			buf.append("INSERT INTO NC_PROTOCOLMANIP ");
			buf
					.append(" (UNIQUEID,TABLEID,OWNER,MODTIME,MODUSER,TYPE,START_VALUE,END_VALUE,PROTOCOLVERSION,PROTOCOLID,NC_EXPMANIPULATION_UNIQUEID) ");
			buf.append("VALUES ");

			buf.append('(');
			for (int i = 0; i < 11; ++i) {
				buf.append('?');
				if (i < 10)
					buf.append(',');
			}
			buf.append(")");
			ps = con.prepareStatement(buf.toString());
			ps.clearParameters();
			ps.setObject(1, (java.math.BigDecimal) bean.getUniqueid(),
					Types.NUMERIC);
			ps.setObject(2, (java.math.BigDecimal) bean.getTableid(),
					Types.NUMERIC);
			ps.setObject(3, (java.math.BigDecimal) bean.getOwner(), Types.NUMERIC);
			ps.setTimestamp(4, bean.getModtime() == null ? null
					: new java.sql.Timestamp(bean.getModtime().getTime()));
			ps.setObject(5, (java.math.BigDecimal) bean.getModuser(),
					Types.NUMERIC);
			ps.setObject(6, (String) bean.getType(), Types.VARCHAR);
			ps.setObject(7, (java.math.BigDecimal) bean.getStartValue(),
					Types.NUMERIC);
			ps.setObject(8, (java.math.BigDecimal) bean.getEndValue(),
					Types.NUMERIC);
			ps.setObject(9, (java.math.BigDecimal) bean.getProtocolversion(),
					Types.NUMERIC);
			ps.setObject(10, (String) bean.getProtocolid(), Types.VARCHAR);
			ps.setObject(11, (java.math.BigDecimal) bean
					.getNcExpmanipulationUniqueid(), Types.NUMERIC);
			ps.executeUpdate();

		} finally {
			if (ps != null)
				try {
					ps.close();
				} catch (Exception x) { /* ignore */
				}
		}
	}

	protected String prepareColList(Protocolmanip bean) {
		StringBuffer buf = new StringBuffer(200);
		buf.append("UNIQUEID");
		buf.append(',');
		buf.append("TABLEID");
		buf.append(',');
		buf.append("OWNER");
		buf.append(',');
		buf.append("MODTIME");
		buf.append(',');
		buf.append("MODUSER");
		buf.append(',');
		buf.append("TYPE");
		buf.append(',');
		buf.append("START_VALUE");
		buf.append(',');
		buf.append("END_VALUE");
		buf.append(',');
		buf.append("PROTOCOLVERSION");
		buf.append(',');
		buf.append("PROTOCOLID");
		buf.append(',');
		buf.append("NC_EXPMANIPULATION_UNIQUEID");
		buf.append(' ');
		return buf.toString();
	}

	protected QueryInfo prepareWhereClause(Protocolmanip bean) {
		StringBuffer buf = new StringBuffer(200);
		QueryInfo qi = new QueryInfo();
		boolean valueSet = false;
		buf.append("WHERE ");

		if (bean.getUniqueid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("UNIQUEID=?");
			qi.values.add(bean.getUniqueid());
			valueSet = true;
		}
		if (bean.getTableid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("TABLEID=?");
			qi.values.add(bean.getTableid());
			valueSet = true;
		}
		if (bean.getOwner() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("OWNER=?");
			qi.values.add(bean.getOwner());
			valueSet = true;
		}
		if (bean.getModtime() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("MODTIME=?");
			qi.values.add(new java.sql.Timestamp(bean.getModtime().getTime()));
			valueSet = true;
		}
		if (bean.getModuser() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("MODUSER=?");
			qi.values.add(bean.getModuser());
			valueSet = true;
		}
		if (bean.getType() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("TYPE=?");
			qi.values.add(bean.getType());
			valueSet = true;
		}
		if (bean.getStartValue() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("START_VALUE=?");
			qi.values.add(bean.getStartValue());
			valueSet = true;
		}
		if (bean.getEndValue() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("END_VALUE=?");
			qi.values.add(bean.getEndValue());
			valueSet = true;
		}
		if (bean.getProtocolversion() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("PROTOCOLVERSION=?");
			qi.values.add(bean.getProtocolversion());
			valueSet = true;
		}
		if (bean.getProtocolid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("PROTOCOLID=?");
			qi.values.add(bean.getProtocolid());
			valueSet = true;
		}
		if (bean.getNcExpmanipulationUniqueid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("NC_EXPMANIPULATION_UNIQUEID=?");
			qi.values.add(bean.getNcExpmanipulationUniqueid());
			valueSet = true;
		}
		qi.whereClause = (!valueSet) ? "" : buf.toString();
		return qi;
	}

	protected UpdateQueryInfo prepareUpdateQuery(Protocolmanip bean,
			Protocolmanip criteria) throws ValidationException {
		StringBuffer buf = new StringBuffer(200);
		UpdateQueryInfo uqi = new UpdateQueryInfo();
		boolean valueSet = false;
		buf.append("UPDATE NC_PROTOCOLMANIP SET ");

		if (bean.getUniqueid() != null || bean.isNull("uniqueid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("UNIQUEID=? ");
			uqi.setValues.add(bean.getUniqueid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("uniqueid"), uqi);
			valueSet = true;
		}
		if (bean.getTableid() != null || bean.isNull("tableid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("TABLEID=? ");
			uqi.setValues.add(bean.getTableid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("tableid"), uqi);
			valueSet = true;
		}
		if (bean.getOwner() != null || bean.isNull("owner")) {
			if (valueSet)
				buf.append(", ");
			buf.append("OWNER=? ");
			uqi.setValues.add(bean.getOwner());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("owner"), uqi);
			valueSet = true;
		}
		if (bean.getModtime() != null || bean.isNull("modtime")) {
			if (valueSet)
				buf.append(", ");
			buf.append("MODTIME=? ");
			uqi.setValues.add(new java.sql.Timestamp(bean.getModtime().getTime()));
			uqi.sqlTypes.add(new Integer(Types.DATE));
			prepareNullSetListValue(bean.isNull("modtime"), uqi);
			valueSet = true;
		}
		if (bean.getModuser() != null || bean.isNull("moduser")) {
			if (valueSet)
				buf.append(", ");
			buf.append("MODUSER=? ");
			uqi.setValues.add(bean.getModuser());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("moduser"), uqi);
			valueSet = true;
		}
		if (bean.getType() != null || bean.isNull("type")) {
			if (valueSet)
				buf.append(", ");
			buf.append("TYPE=? ");
			uqi.setValues.add(bean.getType());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("type"), uqi);
			valueSet = true;
		}
		if (bean.getStartValue() != null || bean.isNull("startValue")) {
			if (valueSet)
				buf.append(", ");
			buf.append("START_VALUE=? ");
			uqi.setValues.add(bean.getStartValue());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("startValue"), uqi);
			valueSet = true;
		}
		if (bean.getEndValue() != null || bean.isNull("endValue")) {
			if (valueSet)
				buf.append(", ");
			buf.append("END_VALUE=? ");
			uqi.setValues.add(bean.getEndValue());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("endValue"), uqi);
			valueSet = true;
		}
		if (bean.getProtocolversion() != null || bean.isNull("protocolversion")) {
			if (valueSet)
				buf.append(", ");
			buf.append("PROTOCOLVERSION=? ");
			uqi.setValues.add(bean.getProtocolversion());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("protocolversion"), uqi);
			valueSet = true;
		}
		if (bean.getProtocolid() != null || bean.isNull("protocolid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("PROTOCOLID=? ");
			uqi.setValues.add(bean.getProtocolid());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("protocolid"), uqi);
			valueSet = true;
		}
		if (bean.getNcExpmanipulationUniqueid() != null
				|| bean.isNull("ncExpmanipulationUniqueid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("NC_EXPMANIPULATION_UNIQUEID=? ");
			uqi.setValues.add(bean.getNcExpmanipulationUniqueid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("ncExpmanipulationUniqueid"), uqi);
			valueSet = true;
		}
		if (!valueSet)
			throw new ValidationException(
					"At least one field needs to be set for update!");

		uqi.query = buf.toString();
		QueryInfo qi = prepareWhereClause(criteria);
		uqi.query += qi.whereClause;
		uqi.whereValues = qi.values;
		return uqi;
	}

	protected void prepareNullSetListValue(boolean wasNull, UpdateQueryInfo uqi) {
		if (wasNull) {
			uqi.nullSetList.add(new Boolean(true));
		} else {
			uqi.nullSetList.add(new Boolean(false));
		}
	}

	public Protocolmanip createObject(ResultSet rs) throws SQLException {
		Protocolmanip obj = new Protocolmanip();
		obj.setUniqueid((java.math.BigDecimal) rs.getObject(1));
		obj.setTableid((java.math.BigDecimal) rs.getObject(2));
		obj.setOwner((java.math.BigDecimal) rs.getObject(3));
		if (rs.getTimestamp(4) != null) {
			obj.setModtime(new java.util.Date(rs.getTimestamp(4).getTime()));
		}
		obj.setModuser((java.math.BigDecimal) rs.getObject(5));
		obj.setType((String) rs.getObject(6));
		obj.setStartValue((java.math.BigDecimal) rs.getObject(7));
		obj.setEndValue((java.math.BigDecimal) rs.getObject(8));
		obj.setProtocolversion((java.math.BigDecimal) rs.getObject(9));
		obj.setProtocolid((String) rs.getObject(10));
		obj.setNcExpmanipulationUniqueid((java.math.BigDecimal) rs.getObject(11));
		return obj;
	}

	public List<Protocolmanip> find(Connection con, Protocolmanip criteria)
			throws Exception {

		PreparedStatement ps = null;
		ResultSet rs = null;
		List<Protocolmanip> results = new LinkedList<Protocolmanip>();
		StringBuffer buf = new StringBuffer(200);

		if (criteria == null)
			return null;
		buf.append("SELECT ");
		buf.append(prepareColList(criteria));
		buf.append(" FROM NC_PROTOCOLMANIP ");
		QueryInfo qi = prepareWhereClause(criteria);
		buf.append(qi.whereClause);
		try {
			ps = con.prepareStatement(buf.toString());
			ps.clearParameters();
			int i = 0;
			for (Iterator<?> it = qi.values.iterator(); it.hasNext();) {
				ps.setObject(++i, it.next());
			}
			rs = ps.executeQuery();
			while (rs.next()) {
				Protocolmanip item = createObject(rs);
				results.add(item);
			}
		} finally {
			DBUtils.close(ps, rs);
		}
		return results;
	}

	public void update(Connection con, Protocolmanip bean, Protocolmanip criteria)
			throws Exception {

		PreparedStatement ps = null;

		if (bean == null)
			return;

		UpdateQueryInfo uqi = prepareUpdateQuery(bean, criteria);
		try {
			ps = con.prepareStatement(uqi.query);
			ps.clearParameters();
			int i = 0;
			Iterator<Integer> it2 = uqi.sqlTypes.iterator();
			Iterator<Boolean> it3 = uqi.nullSetList.iterator();
			for (Iterator<?> it = uqi.setValues.iterator(); it.hasNext();) {
				Object value = it.next();
				Integer sqlType = (Integer) it2.next();
				boolean nullSet = ((Boolean) it3.next()).booleanValue();
				if (nullSet) {
					ps.setNull(++i, sqlType.intValue());
				} else {
					ps.setObject(++i, value);
				}
			}
			// for where part
			for (Iterator<?> it = uqi.whereValues.iterator(); it.hasNext();) {
				ps.setObject(++i, it.next());
			}
			ps.executeUpdate();
		} finally {
			DBUtils.close(ps);
		}
	}

	public void delete(Connection con, Protocolmanip criteria) throws Exception {
		PreparedStatement ps = null;
		StringBuffer buf = new StringBuffer(200);
		buf.append("DELETE FROM NC_PROTOCOLMANIP ");

		QueryInfo qi = prepareWhereClause(criteria);
		buf.append(qi.whereClause);
		try {
			ps = con.prepareStatement(buf.toString());
			ps.clearParameters();
			int i = 0;
			for (Iterator<?> it = qi.values.iterator(); it.hasNext();) {
				ps.setObject(++i, it.next());
			}
			ps.executeUpdate();

		} finally {
			DBUtils.close(ps);
		}
	}

	public static class QueryInfo {
		String whereClause;
		List<? super Object> values = new LinkedList<Object>();

		public QueryInfo() {}

		public QueryInfo(String whereClause) {
			this.whereClause = whereClause;
		}
	}

	public static class UpdateQueryInfo {
		String query;
		List<? super Object> setValues = new LinkedList<Object>();
		List<Integer> sqlTypes = new LinkedList<Integer>();
		List<Boolean> nullSetList = new LinkedList<Boolean>();
		List<? super Object> whereValues = new LinkedList<Object>();

		public UpdateQueryInfo() {}
	}

	/* +++ */
	// Enter your code here
	/* +++ */
}// ;
