package clinical.server.dao.oracle;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import clinical.server.utils.OracleUtils;
import clinical.server.vo.Storedassessment;
import clinical.web.DBUtils;
import clinical.web.exception.ValidationException;

public class StoredassessmentDAO implements
		clinical.server.dao.StoredassessmentDAO {
	/* +++ */
	// Enter your declarations here
	/* +++ */

	public StoredassessmentDAO() {}

	public void insert(Connection con, Storedassessment bean) throws Exception {
		PreparedStatement ps = null;
		StringBuffer buf = new StringBuffer(200);

		if (bean == null)
			return;
		try {
			buf.append("INSERT INTO NC_STOREDASSESSMENT ");
			buf
					.append(" (UNIQUEID,ASSESSMENTID,TABLEID,OWNER,MODTIME,MODUSER,COMPONENTID,NC_EXPERIMENT_UNIQUEID,SEGMENTID,SUBJECTID,TIME_STAMP,INFORMANTID,INFORMANTRELATION,ISVALIDATED,STATUS,RATORQUALITY,ISTIMEINTERVAL,TIMEINTERVAL) ");
			buf.append("VALUES ");

			buf.append('(');
			for (int i = 0; i < 18; ++i) {
				buf.append('?');
				if (i < 17)
					buf.append(',');
			}
			buf.append(")");
			ps = con.prepareStatement(buf.toString());
			ps.clearParameters();
			ps.setObject(1, (java.math.BigDecimal) bean.getUniqueid(),
					Types.NUMERIC);
			ps.setObject(2, (java.math.BigDecimal) bean.getAssessmentid(),
					Types.NUMERIC);
			ps.setObject(3, (java.math.BigDecimal) bean.getTableid(),
					Types.NUMERIC);
			ps.setObject(4, (java.math.BigDecimal) bean.getOwner(), Types.NUMERIC);
			ps.setTimestamp(5, bean.getModtime() == null ? null
					: new java.sql.Timestamp(bean.getModtime().getTime()));
			ps.setObject(6, (java.math.BigDecimal) bean.getModuser(),
					Types.NUMERIC);
			ps.setObject(7, (java.math.BigDecimal) bean.getComponentid(),
					Types.NUMERIC);
			ps.setObject(8, (java.math.BigDecimal) bean.getNcExperimentUniqueid(),
					Types.NUMERIC);
			ps.setObject(9, (java.math.BigDecimal) bean.getSegmentid(),
					Types.NUMERIC);
			ps.setObject(10, (String) bean.getSubjectid(), Types.VARCHAR);
			ps.setObject(11, (java.sql.Timestamp) bean.getTimeStamp(),
					Types.TIMESTAMP);
			ps.setObject(12, (String) bean.getInformantid(), Types.VARCHAR);
			ps.setObject(13, (String) bean.getInformantrelation(), Types.VARCHAR);
			ps.setObject(14, boolean2Number((Boolean) bean.getIsvalidated()),
					Types.NUMERIC);
			ps.setObject(15, (String) bean.getStatus(), Types.VARCHAR);
			ps.setObject(16, (String) bean.getRatorquality(), Types.VARCHAR);
			ps.setObject(17, boolean2Number((Boolean) bean.getIstimeinterval()),
					Types.NUMERIC);
			ps.setObject(18, (Float) bean.getTimeinterval(), Types.FLOAT);
			ps.executeUpdate();

		} finally {
			if (ps != null)
				try {
					ps.close();
				} catch (Exception x) { /* ignore */
				}
		}
	}

	protected String prepareColList(Storedassessment bean) {
		StringBuffer buf = new StringBuffer(200);
		buf.append("UNIQUEID");
		buf.append(',');
		buf.append("ASSESSMENTID");
		buf.append(',');
		buf.append("TABLEID");
		buf.append(',');
		buf.append("OWNER");
		buf.append(',');
		buf.append("MODTIME");
		buf.append(',');
		buf.append("MODUSER");
		buf.append(',');
		buf.append("COMPONENTID");
		buf.append(',');
		buf.append("NC_EXPERIMENT_UNIQUEID");
		buf.append(',');
		buf.append("SEGMENTID");
		buf.append(',');
		buf.append("SUBJECTID");
		buf.append(',');
		buf.append("TIME_STAMP");
		buf.append(',');
		buf.append("INFORMANTID");
		buf.append(',');
		buf.append("INFORMANTRELATION");
		buf.append(',');
		buf.append("ISVALIDATED");
		buf.append(',');
		buf.append("STATUS");
		buf.append(',');
		buf.append("RATORQUALITY");
		buf.append(',');
		buf.append("ISTIMEINTERVAL");
		buf.append(',');
		buf.append("TIMEINTERVAL");
		buf.append(' ');
		return buf.toString();
	}

	protected QueryInfo prepareWhereClause(Storedassessment bean) {
		StringBuffer buf = new StringBuffer(200);
		QueryInfo qi = new QueryInfo();
		boolean valueSet = false;
		buf.append("WHERE ");

		if (bean.getUniqueid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("UNIQUEID=?");
			qi.values.add(bean.getUniqueid());
			valueSet = true;
		}
		if (bean.getAssessmentid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("ASSESSMENTID=?");
			qi.values.add(bean.getAssessmentid());
			valueSet = true;
		}
		if (bean.getTableid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("TABLEID=?");
			qi.values.add(bean.getTableid());
			valueSet = true;
		}
		if (bean.getOwner() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("OWNER=?");
			qi.values.add(bean.getOwner());
			valueSet = true;
		}
		if (bean.getModtime() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("MODTIME=?");
			qi.values.add(new java.sql.Timestamp(bean.getModtime().getTime()));
			valueSet = true;
		}
		if (bean.getModuser() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("MODUSER=?");
			qi.values.add(bean.getModuser());
			valueSet = true;
		}
		if (bean.getComponentid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("COMPONENTID=?");
			qi.values.add(bean.getComponentid());
			valueSet = true;
		}
		if (bean.getNcExperimentUniqueid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("NC_EXPERIMENT_UNIQUEID=?");
			qi.values.add(bean.getNcExperimentUniqueid());
			valueSet = true;
		}
		if (bean.getSegmentid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("SEGMENTID=?");
			qi.values.add(bean.getSegmentid());
			valueSet = true;
		}
		if (bean.getSubjectid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("SUBJECTID=?");
			qi.values.add(bean.getSubjectid());
			valueSet = true;
		}
		if (bean.getTimeStamp() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("TIME_STAMP=?");
			qi.values.add(bean.getTimeStamp());
			valueSet = true;
		}
		if (bean.getInformantid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("INFORMANTID=?");
			qi.values.add(bean.getInformantid());
			valueSet = true;
		}
		if (bean.getInformantrelation() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("INFORMANTRELATION=?");
			qi.values.add(bean.getInformantrelation());
			valueSet = true;
		}
		if (bean.getIsvalidated() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("ISVALIDATED=?");
			qi.values.add(boolean2Number((Boolean) bean.getIsvalidated()));
			valueSet = true;
		}
		if (bean.getStatus() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("STATUS=?");
			qi.values.add(bean.getStatus());
			valueSet = true;
		}
		if (bean.getRatorquality() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("RATORQUALITY=?");
			qi.values.add(bean.getRatorquality());
			valueSet = true;
		}
		if (bean.getIstimeinterval() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("ISTIMEINTERVAL=?");
			qi.values.add(boolean2Number((Boolean) bean.getIstimeinterval()));
			valueSet = true;
		}
		if (bean.getTimeinterval() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("TIMEINTERVAL=?");
			qi.values.add(bean.getTimeinterval());
			valueSet = true;
		}
		qi.whereClause = (!valueSet) ? "" : buf.toString();
		return qi;
	}

	protected UpdateQueryInfo prepareUpdateQuery(Storedassessment bean,
			Storedassessment criteria) throws ValidationException {
		StringBuffer buf = new StringBuffer(200);
		UpdateQueryInfo uqi = new UpdateQueryInfo();
		boolean valueSet = false;
		buf.append("UPDATE NC_STOREDASSESSMENT SET ");

		if (bean.getUniqueid() != null || bean.isNull("uniqueid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("UNIQUEID=? ");
			uqi.setValues.add(bean.getUniqueid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("uniqueid"), uqi);
			valueSet = true;
		}
		if (bean.getAssessmentid() != null || bean.isNull("assessmentid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("ASSESSMENTID=? ");
			uqi.setValues.add(bean.getAssessmentid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("assessmentid"), uqi);
			valueSet = true;
		}
		if (bean.getTableid() != null || bean.isNull("tableid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("TABLEID=? ");
			uqi.setValues.add(bean.getTableid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("tableid"), uqi);
			valueSet = true;
		}
		if (bean.getOwner() != null || bean.isNull("owner")) {
			if (valueSet)
				buf.append(", ");
			buf.append("OWNER=? ");
			uqi.setValues.add(bean.getOwner());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("owner"), uqi);
			valueSet = true;
		}
		if (bean.getModtime() != null || bean.isNull("modtime")) {
			if (valueSet)
				buf.append(", ");
			buf.append("MODTIME=? ");
			uqi.setValues.add(new java.sql.Timestamp(bean.getModtime().getTime()));
			uqi.sqlTypes.add(new Integer(Types.DATE));
			prepareNullSetListValue(bean.isNull("modtime"), uqi);
			valueSet = true;
		}
		if (bean.getModuser() != null || bean.isNull("moduser")) {
			if (valueSet)
				buf.append(", ");
			buf.append("MODUSER=? ");
			uqi.setValues.add(bean.getModuser());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("moduser"), uqi);
			valueSet = true;
		}
		if (bean.getComponentid() != null || bean.isNull("componentid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("COMPONENTID=? ");
			uqi.setValues.add(bean.getComponentid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("componentid"), uqi);
			valueSet = true;
		}
		if (bean.getNcExperimentUniqueid() != null
				|| bean.isNull("ncExperimentUniqueid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("NC_EXPERIMENT_UNIQUEID=? ");
			uqi.setValues.add(bean.getNcExperimentUniqueid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("ncExperimentUniqueid"), uqi);
			valueSet = true;
		}
		if (bean.getSegmentid() != null || bean.isNull("segmentid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("SEGMENTID=? ");
			uqi.setValues.add(bean.getSegmentid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("segmentid"), uqi);
			valueSet = true;
		}
		if (bean.getSubjectid() != null || bean.isNull("subjectid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("SUBJECTID=? ");
			uqi.setValues.add(bean.getSubjectid());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("subjectid"), uqi);
			valueSet = true;
		}
		if (bean.getTimeStamp() != null || bean.isNull("timeStamp")) {
			if (valueSet)
				buf.append(", ");
			buf.append("TIME_STAMP=? ");
			uqi.setValues.add(bean.getTimeStamp());
			uqi.sqlTypes.add(new Integer(Types.TIMESTAMP));
			prepareNullSetListValue(bean.isNull("timeStamp"), uqi);
			valueSet = true;
		}
		if (bean.getInformantid() != null || bean.isNull("informantid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("INFORMANTID=? ");
			uqi.setValues.add(bean.getInformantid());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("informantid"), uqi);
			valueSet = true;
		}
		if (bean.getInformantrelation() != null
				|| bean.isNull("informantrelation")) {
			if (valueSet)
				buf.append(", ");
			buf.append("INFORMANTRELATION=? ");
			uqi.setValues.add(bean.getInformantrelation());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("informantrelation"), uqi);
			valueSet = true;
		}
		if (bean.getIsvalidated() != null || bean.isNull("isvalidated")) {
			if (valueSet)
				buf.append(", ");
			buf.append("ISVALIDATED=? ");
			uqi.setValues.add(boolean2Number((Boolean) bean.getIsvalidated()));
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("isvalidated"), uqi);
			valueSet = true;
		}
		if (bean.getStatus() != null || bean.isNull("status")) {
			if (valueSet)
				buf.append(", ");
			buf.append("STATUS=? ");
			uqi.setValues.add(bean.getStatus());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("status"), uqi);
			valueSet = true;
		}
		if (bean.getRatorquality() != null || bean.isNull("ratorquality")) {
			if (valueSet)
				buf.append(", ");
			buf.append("RATORQUALITY=? ");
			uqi.setValues.add(bean.getRatorquality());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("ratorquality"), uqi);
			valueSet = true;
		}
		if (bean.getIstimeinterval() != null || bean.isNull("istimeinterval")) {
			if (valueSet)
				buf.append(", ");
			buf.append("ISTIMEINTERVAL=? ");
			uqi.setValues.add(boolean2Number((Boolean) bean.getIstimeinterval()));
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("istimeinterval"), uqi);
			valueSet = true;
		}
		if (bean.getTimeinterval() != null || bean.isNull("timeinterval")) {
			if (valueSet)
				buf.append(", ");
			buf.append("TIMEINTERVAL=? ");
			uqi.setValues.add(bean.getTimeinterval());
			uqi.sqlTypes.add(new Integer(Types.FLOAT));
			prepareNullSetListValue(bean.isNull("timeinterval"), uqi);
			valueSet = true;
		}
		if (!valueSet)
			throw new ValidationException(
					"At least one field needs to be set for update!");

		uqi.query = buf.toString();
		QueryInfo qi = prepareWhereClause(criteria);
		uqi.query += qi.whereClause;
		uqi.whereValues = qi.values;
		return uqi;
	}

	protected void prepareNullSetListValue(boolean wasNull, UpdateQueryInfo uqi) {
		if (wasNull) {
			uqi.nullSetList.add(new Boolean(true));
		} else {
			uqi.nullSetList.add(new Boolean(false));
		}
	}

	protected Boolean convert2Boolean(Object columnValue) {
		if (columnValue == null)
			return null;
		return ((java.math.BigDecimal) columnValue).intValue() > 0 ? new Boolean(
				true) : new Boolean(false);
	}

	protected BigDecimal boolean2Number(Boolean value) {
		if (value == null)
			return null;
		return ((Boolean) value).booleanValue() ? new java.math.BigDecimal("1")
				: new java.math.BigDecimal("0");
	}

	protected String boolean2YN(Boolean value) {
		if (value == null)
			return null;
		return ((Boolean) value).booleanValue() ? "Y" : "N";
	}

	public Storedassessment createObject(ResultSet rs) throws SQLException {
		Storedassessment obj = new Storedassessment();
		obj.setUniqueid((java.math.BigDecimal) rs.getObject(1));
		obj.setAssessmentid((java.math.BigDecimal) rs.getObject(2));
		obj.setTableid((java.math.BigDecimal) rs.getObject(3));
		obj.setOwner((java.math.BigDecimal) rs.getObject(4));
		if (rs.getTimestamp(5) != null) {
			obj.setModtime(new java.util.Date(rs.getTimestamp(5).getTime()));
		}
		obj.setModuser((java.math.BigDecimal) rs.getObject(6));
		obj.setComponentid((java.math.BigDecimal) rs.getObject(7));
		obj.setNcExperimentUniqueid((java.math.BigDecimal) rs.getObject(8));
		obj.setSegmentid((java.math.BigDecimal) rs.getObject(9));
		obj.setSubjectid((String) rs.getObject(10));
		obj.setTimeStamp(OracleUtils.getTimestamp(rs.getObject(11)));
		obj.setInformantid((String) rs.getObject(12));
		obj.setInformantrelation((String) rs.getObject(13));
		obj.setIsvalidated(convert2Boolean(rs.getObject(14)));
		obj.setStatus((String) rs.getObject(15));
		obj.setRatorquality((String) rs.getObject(16));
		obj.setIstimeinterval(convert2Boolean(rs.getObject(17)));
		obj.setTimeinterval((Float) rs.getObject(18));
		return obj;
	}

	public List<Storedassessment> find(Connection con, Storedassessment criteria)
			throws Exception {

		PreparedStatement ps = null;
		ResultSet rs = null;
		List<Storedassessment> results = new LinkedList<Storedassessment>();
		StringBuffer buf = new StringBuffer(200);

		if (criteria == null)
			return null;
		buf.append("SELECT ");
		buf.append(prepareColList(criteria));
		buf.append(" FROM NC_STOREDASSESSMENT ");
		QueryInfo qi = prepareWhereClause(criteria);
		buf.append(qi.whereClause);
		try {
			ps = con.prepareStatement(buf.toString());
			ps.clearParameters();
			int i = 0;
			for (Iterator<?> it = qi.values.iterator(); it.hasNext();) {
				ps.setObject(++i, it.next());
			}
			rs = ps.executeQuery();
			while (rs.next()) {
				Storedassessment item = createObject(rs);
				results.add(item);
			}
		} finally {
			DBUtils.close(ps, rs);
		}
		return results;
	}

	public void update(Connection con, Storedassessment bean,
			Storedassessment criteria) throws Exception {

		PreparedStatement ps = null;

		if (bean == null)
			return;

		UpdateQueryInfo uqi = prepareUpdateQuery(bean, criteria);
		try {
			ps = con.prepareStatement(uqi.query);
			ps.clearParameters();
			int i = 0;
			Iterator<Integer> it2 = uqi.sqlTypes.iterator();
			Iterator<Boolean> it3 = uqi.nullSetList.iterator();
			for (Iterator<?> it = uqi.setValues.iterator(); it.hasNext();) {
				Object value = it.next();
				Integer sqlType = (Integer) it2.next();
				boolean nullSet = ((Boolean) it3.next()).booleanValue();
				if (nullSet) {
					ps.setNull(++i, sqlType.intValue());
				} else {
					ps.setObject(++i, value);
				}
			}
			// for where part
			for (Iterator<?> it = uqi.whereValues.iterator(); it.hasNext();) {
				ps.setObject(++i, it.next());
			}
			ps.executeUpdate();
		} finally {
			DBUtils.close(ps);
		}
	}

	public void delete(Connection con, Storedassessment criteria)
			throws Exception {
		PreparedStatement ps = null;
		StringBuffer buf = new StringBuffer(200);
		buf.append("DELETE FROM NC_STOREDASSESSMENT ");

		QueryInfo qi = prepareWhereClause(criteria);
		buf.append(qi.whereClause);
		try {
			ps = con.prepareStatement(buf.toString());
			ps.clearParameters();
			int i = 0;
			for (Iterator<?> it = qi.values.iterator(); it.hasNext();) {
				ps.setObject(++i, it.next());
			}
			ps.executeUpdate();

		} finally {
			DBUtils.close(ps);
		}
	}

	public static class QueryInfo {
		String whereClause;
		List<? super Object> values = new LinkedList<Object>();

		public QueryInfo() {}

		public QueryInfo(String whereClause) {
			this.whereClause = whereClause;
		}
	}

	public static class UpdateQueryInfo {
		String query;
		List<? super Object> setValues = new LinkedList<Object>();
		List<Integer> sqlTypes = new LinkedList<Integer>();
		List<Boolean> nullSetList = new LinkedList<Boolean>();
		List<? super Object> whereValues = new LinkedList<Object>();

		public UpdateQueryInfo() {}
	}

	/* +++ */
	// Enter your code here
	/* +++ */
}// ;
