package clinical.server.dao.postgres;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import clinical.server.vo.Assessmentscore;
import clinical.web.DBUtils;
import clinical.web.exception.ValidationException;

public class AssessmentscoreDAO implements
		clinical.server.dao.AssessmentscoreDAO {
	/* +++ */
	// Enter your declarations here
	/* +++ */

	public AssessmentscoreDAO() {
	}

	public void insert(Connection con, Assessmentscore bean) throws Exception {
		PreparedStatement ps = null;
		StringBuffer buf = new StringBuffer(200);

		if (bean == null)
			return;
		try {
			buf.append("INSERT INTO nc_assessmentscore VALUES ");
			buf.append('(');
			for (int i = 0; i < 24; ++i) {
				buf.append('?');
				if (i < 23)
					buf.append(',');
			}
			buf.append(")");
			ps = con.prepareStatement(buf.toString());
			ps.clearParameters();
			ps.setObject(1, bean.getAssessmentid(), Types.NUMERIC);

			ps.setObject(2, bean.getScorename(), Types.VARCHAR);

			ps.setObject(3, bean.getScoresequence(), Types.NUMERIC);

			ps.setObject(4, bean.getScoretype(), Types.VARCHAR);

			ps.setObject(5, bean.getTableid(), Types.NUMERIC);

			ps.setObject(6, bean.getUniqueid(), Types.NUMERIC);

			ps.setObject(7, bean.getOwner(), Types.NUMERIC);

			ps.setObject(8,
					bean.getModtime() == null ? (java.sql.Timestamp) null
							: new java.sql.Timestamp(bean.getModtime()
									.getTime()));

			ps.setObject(9, bean.getModuser(), Types.NUMERIC);

			ps.setObject(10, bean.getDefaultvalue(), Types.VARCHAR);

			ps.setObject(11, bean.getNullable());

			ps.setObject(12, bean.getScorelevel(), Types.NUMERIC);

			ps.setObject(13, bean.getParentasid(), Types.NUMERIC);

			ps.setObject(14, bean.getParentscore(), Types.VARCHAR);

			ps.setObject(15, bean.getAssessmentontology(), Types.VARCHAR);

			ps.setObject(16, bean.getAssessmentconcept(), Types.VARCHAR);

			ps.setObject(17, bean.getSecurityclassification(), Types.VARCHAR);

			ps.setObject(18, bean.getMinanswers(), Types.NUMERIC);

			ps.setObject(19, bean.getMaxanswers(), Types.NUMERIC);

			ps.setObject(20, bean.getIsrequired());

			ps.setObject(21, bean.getIsexcluded());

			ps.setObject(22, bean.getIsnew());

			ps.setObject(23, bean.getIsmodified());

			ps.setObject(24, bean.getDescription(), Types.VARCHAR);

			ps.executeUpdate();

		} finally {
			DBUtils.close(ps);
		}
	}

	protected String prepareColList(Assessmentscore bean) {
		StringBuffer buf = new StringBuffer(200);
		buf.append("assessmentid");
		buf.append(',');
		buf.append("scorename");
		buf.append(',');
		buf.append("scoresequence");
		buf.append(',');
		buf.append("scoretype");
		buf.append(',');
		buf.append("tableid");
		buf.append(',');
		buf.append("uniqueid");
		buf.append(',');
		buf.append("owner");
		buf.append(',');
		buf.append("modtime");
		buf.append(',');
		buf.append("moduser");
		buf.append(',');
		buf.append("defaultvalue");
		buf.append(',');
		buf.append("nullable");
		buf.append(',');
		buf.append("scorelevel");
		buf.append(',');
		buf.append("parentasid");
		buf.append(',');
		buf.append("parentscore");
		buf.append(',');
		buf.append("assessmentontology");
		buf.append(',');
		buf.append("assessmentconcept");
		buf.append(',');
		buf.append("securityclassification");
		buf.append(',');
		buf.append("minanswers");
		buf.append(',');
		buf.append("maxanswers");
		buf.append(',');
		buf.append("isrequired");
		buf.append(',');
		buf.append("isexcluded");
		buf.append(',');
		buf.append("isnew");
		buf.append(',');
		buf.append("ismodified");
		buf.append(',');
		buf.append("description");
		buf.append(' ');
		return buf.toString();
	}

	protected QueryInfo prepareWhereClause(Assessmentscore bean) {
		StringBuffer buf = new StringBuffer(200);
		QueryInfo qi = new QueryInfo();
		boolean valueSet = false;
		buf.append("WHERE ");
		if (bean.getAssessmentid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("assessmentid=?");
			qi.values.add(bean.getAssessmentid());
			valueSet = true;
		}
		if (bean.getScorename() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("scorename=?");
			qi.values.add(bean.getScorename());
			valueSet = true;
		}
		if (bean.getScoresequence() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("scoresequence=?");
			qi.values.add(bean.getScoresequence());
			valueSet = true;
		}
		if (bean.getScoretype() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("scoretype=?");
			qi.values.add(bean.getScoretype());
			valueSet = true;
		}
		if (bean.getTableid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("tableid=?");
			qi.values.add(bean.getTableid());
			valueSet = true;
		}
		if (bean.getUniqueid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("uniqueid=?");
			qi.values.add(bean.getUniqueid());
			valueSet = true;
		}
		if (bean.getOwner() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("owner=?");
			qi.values.add(bean.getOwner());
			valueSet = true;
		}
		if (bean.getModtime() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("modtime=?");
			qi.values.add(new java.sql.Date(bean.getModtime().getTime()));
			valueSet = true;
		}
		if (bean.getModuser() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("moduser=?");
			qi.values.add(bean.getModuser());
			valueSet = true;
		}
		if (bean.getDefaultvalue() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("defaultvalue=?");
			qi.values.add(bean.getDefaultvalue());
			valueSet = true;
		}
		if (bean.getNullable() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("nullable=?");
			qi.values.add(bean.getNullable());
			valueSet = true;
		}
		if (bean.getScorelevel() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("scorelevel=?");
			qi.values.add(bean.getScorelevel());
			valueSet = true;
		}
		if (bean.getParentasid() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("parentasid=?");
			qi.values.add(bean.getParentasid());
			valueSet = true;
		}
		if (bean.getParentscore() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("parentscore=?");
			qi.values.add(bean.getParentscore());
			valueSet = true;
		}
		if (bean.getAssessmentontology() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("assessmentontology=?");
			qi.values.add(bean.getAssessmentontology());
			valueSet = true;
		}
		if (bean.getAssessmentconcept() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("assessmentconcept=?");
			qi.values.add(bean.getAssessmentconcept());
			valueSet = true;
		}
		if (bean.getSecurityclassification() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("securityclassification=?");
			qi.values.add(bean.getSecurityclassification());
			valueSet = true;
		}
		if (bean.getMinanswers() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("minanswers=?");
			qi.values.add(bean.getMinanswers());
			valueSet = true;
		}
		if (bean.getMaxanswers() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("maxanswers=?");
			qi.values.add(bean.getMaxanswers());
			valueSet = true;
		}
		if (bean.getIsrequired() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("isrequired=?");
			qi.values.add(bean.getIsrequired());
			valueSet = true;
		}
		if (bean.getIsexcluded() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("isexcluded=?");
			qi.values.add(bean.getIsexcluded());
			valueSet = true;
		}
		if (bean.getIsnew() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("isnew=?");
			qi.values.add(bean.getIsnew());
			valueSet = true;
		}
		if (bean.getIsmodified() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("ismodified=?");
			qi.values.add(bean.getIsmodified());
			valueSet = true;
		}
		if (bean.getDescription() != null) {
			if (valueSet)
				buf.append(" AND ");
			buf.append("description=?");
			qi.values.add(bean.getDescription());
			valueSet = true;
		}
		qi.whereClause = (!valueSet) ? "" : buf.toString();
		return qi;
	}

	protected UpdateQueryInfo prepareUpdateQuery(Assessmentscore bean,
			Assessmentscore criteria) throws ValidationException {
		StringBuffer buf = new StringBuffer(200);
		UpdateQueryInfo uqi = new UpdateQueryInfo();
		boolean valueSet = false;
		buf.append("UPDATE nc_assessmentscore SET ");
		if (bean.getAssessmentid() != null || bean.isNull("assessmentid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("assessmentid=? ");
			uqi.setValues.add(bean.getAssessmentid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("assessmentid"), uqi);
			valueSet = true;
		}
		if (bean.getScorename() != null || bean.isNull("scorename")) {
			if (valueSet)
				buf.append(", ");
			buf.append("scorename=? ");
			uqi.setValues.add(bean.getScorename());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("scorename"), uqi);
			valueSet = true;
		}
		if (bean.getScoresequence() != null || bean.isNull("scoresequence")) {
			if (valueSet)
				buf.append(", ");
			buf.append("scoresequence=? ");
			uqi.setValues.add(bean.getScoresequence());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("scoresequence"), uqi);
			valueSet = true;
		}
		if (bean.getScoretype() != null || bean.isNull("scoretype")) {
			if (valueSet)
				buf.append(", ");
			buf.append("scoretype=? ");
			uqi.setValues.add(bean.getScoretype());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("scoretype"), uqi);
			valueSet = true;
		}
		if (bean.getTableid() != null || bean.isNull("tableid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("tableid=? ");
			uqi.setValues.add(bean.getTableid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("tableid"), uqi);
			valueSet = true;
		}
		if (bean.getUniqueid() != null || bean.isNull("uniqueid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("uniqueid=? ");
			uqi.setValues.add(bean.getUniqueid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("uniqueid"), uqi);
			valueSet = true;
		}
		if (bean.getOwner() != null || bean.isNull("owner")) {
			if (valueSet)
				buf.append(", ");
			buf.append("owner=? ");
			uqi.setValues.add(bean.getOwner());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("owner"), uqi);
			valueSet = true;
		}
		if (bean.getModtime() != null || bean.isNull("modtime")) {
			if (valueSet)
				buf.append(", ");
			buf.append("modtime=? ");
			uqi.setValues.add(new java.sql.Timestamp(bean.getModtime()
					.getTime()));
			uqi.sqlTypes.add(new Integer(Types.TIMESTAMP));
			prepareNullSetListValue(bean.isNull("modtime"), uqi);
			valueSet = true;
		}
		if (bean.getModuser() != null || bean.isNull("moduser")) {
			if (valueSet)
				buf.append(", ");
			buf.append("moduser=? ");
			uqi.setValues.add(bean.getModuser());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("moduser"), uqi);
			valueSet = true;
		}
		if (bean.getDefaultvalue() != null || bean.isNull("defaultvalue")) {
			if (valueSet)
				buf.append(", ");
			buf.append("defaultvalue=? ");
			uqi.setValues.add(bean.getDefaultvalue());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("defaultvalue"), uqi);
			valueSet = true;
		}
		if (bean.getNullable() != null || bean.isNull("nullable")) {
			if (valueSet)
				buf.append(", ");
			buf.append("nullable=? ");
			uqi.setValues.add(bean.getNullable());
			uqi.sqlTypes.add(new Integer(Types.BOOLEAN));
			prepareNullSetListValue(bean.isNull("nullable"), uqi);
			valueSet = true;
		}
		if (bean.getScorelevel() != null || bean.isNull("scorelevel")) {
			if (valueSet)
				buf.append(", ");
			buf.append("scorelevel=? ");
			uqi.setValues.add(bean.getScorelevel());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("scorelevel"), uqi);
			valueSet = true;
		}
		if (bean.getParentasid() != null || bean.isNull("parentasid")) {
			if (valueSet)
				buf.append(", ");
			buf.append("parentasid=? ");
			uqi.setValues.add(bean.getParentasid());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("parentasid"), uqi);
			valueSet = true;
		}
		if (bean.getParentscore() != null || bean.isNull("parentscore")) {
			if (valueSet)
				buf.append(", ");
			buf.append("parentscore=? ");
			uqi.setValues.add(bean.getParentscore());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("parentscore"), uqi);
			valueSet = true;
		}
		if (bean.getAssessmentontology() != null
				|| bean.isNull("assessmentontology")) {
			if (valueSet)
				buf.append(", ");
			buf.append("assessmentontology=? ");
			uqi.setValues.add(bean.getAssessmentontology());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("assessmentontology"), uqi);
			valueSet = true;
		}
		if (bean.getAssessmentconcept() != null
				|| bean.isNull("assessmentconcept")) {
			if (valueSet)
				buf.append(", ");
			buf.append("assessmentconcept=? ");
			uqi.setValues.add(bean.getAssessmentconcept());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("assessmentconcept"), uqi);
			valueSet = true;
		}
		if (bean.getSecurityclassification() != null
				|| bean.isNull("securityclassification")) {
			if (valueSet)
				buf.append(", ");
			buf.append("securityclassification=? ");
			uqi.setValues.add(bean.getSecurityclassification());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("securityclassification"), uqi);
			valueSet = true;
		}
		if (bean.getMinanswers() != null || bean.isNull("minanswers")) {
			if (valueSet)
				buf.append(", ");
			buf.append("minanswers=? ");
			uqi.setValues.add(bean.getMinanswers());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("minanswers"), uqi);
			valueSet = true;
		}
		if (bean.getMaxanswers() != null || bean.isNull("maxanswers")) {
			if (valueSet)
				buf.append(", ");
			buf.append("maxanswers=? ");
			uqi.setValues.add(bean.getMaxanswers());
			uqi.sqlTypes.add(new Integer(Types.NUMERIC));
			prepareNullSetListValue(bean.isNull("maxanswers"), uqi);
			valueSet = true;
		}
		if (bean.getIsrequired() != null || bean.isNull("isrequired")) {
			if (valueSet)
				buf.append(", ");
			buf.append("isrequired=? ");
			uqi.setValues.add(bean.getIsrequired());
			uqi.sqlTypes.add(new Integer(Types.BOOLEAN));
			prepareNullSetListValue(bean.isNull("isrequired"), uqi);
			valueSet = true;
		}
		if (bean.getIsexcluded() != null || bean.isNull("isexcluded")) {
			if (valueSet)
				buf.append(", ");
			buf.append("isexcluded=? ");
			uqi.setValues.add(bean.getIsexcluded());
			uqi.sqlTypes.add(new Integer(Types.BOOLEAN));
			prepareNullSetListValue(bean.isNull("isexcluded"), uqi);
			valueSet = true;
		}
		if (bean.getIsnew() != null || bean.isNull("isnew")) {
			if (valueSet)
				buf.append(", ");
			buf.append("isnew=? ");
			uqi.setValues.add(bean.getIsnew());
			uqi.sqlTypes.add(new Integer(Types.BOOLEAN));
			prepareNullSetListValue(bean.isNull("isnew"), uqi);
			valueSet = true;
		}
		if (bean.getIsmodified() != null || bean.isNull("ismodified")) {
			if (valueSet)
				buf.append(", ");
			buf.append("ismodified=? ");
			uqi.setValues.add(bean.getIsmodified());
			uqi.sqlTypes.add(new Integer(Types.BOOLEAN));
			prepareNullSetListValue(bean.isNull("ismodified"), uqi);
			valueSet = true;
		}
		if (bean.getDescription() != null || bean.isNull("description")) {
			if (valueSet)
				buf.append(", ");
			buf.append("description=? ");
			uqi.setValues.add(bean.getDescription());
			uqi.sqlTypes.add(new Integer(Types.VARCHAR));
			prepareNullSetListValue(bean.isNull("description"), uqi);
			valueSet = true;
		}
		if (!valueSet)
			throw new ValidationException(
					"At least one field needs to be set for update!");

		uqi.query = buf.toString();
		QueryInfo qi = prepareWhereClause(criteria);
		uqi.query += qi.whereClause;
		uqi.whereValues = qi.values;
		return uqi;
	}

	protected void prepareNullSetListValue(boolean wasNull, UpdateQueryInfo uqi) {
		if (wasNull) {
			uqi.nullSetList.add(new Boolean(true));
		} else {
			uqi.nullSetList.add(new Boolean(false));
		}
	}

	protected Boolean convert2Boolean(Object columnValue) {
		if (columnValue == null)
			return null;
		return ((java.math.BigDecimal) columnValue).intValue() > 0 ? new Boolean(
				true)
				: new Boolean(false);
	}

	protected BigDecimal boolean2Number(Boolean value) {
		if (value == null)
			return null;
		return ((Boolean) value).booleanValue() ? new java.math.BigDecimal("1")
				: new java.math.BigDecimal("0");
	}

	protected String boolean2YN(Boolean value) {
		if (value == null)
			return null;
		return ((Boolean) value).booleanValue() ? "Y" : "N";
	}

	public Assessmentscore createObject(ResultSet rs) throws SQLException {
		Assessmentscore obj = new Assessmentscore();
		obj
				.setAssessmentid((rs.getObject(1) != null) ? new java.math.BigDecimal(
						rs.getObject(1).toString())
						: null);
		obj.setScorename((String) rs.getObject(2));
		obj
				.setScoresequence((rs.getObject(3) != null) ? new java.math.BigDecimal(
						rs.getObject(3).toString())
						: null);
		obj.setScoretype((String) rs.getObject(4));
		obj.setTableid((rs.getObject(5) != null) ? new java.math.BigDecimal(rs
				.getObject(5).toString()) : null);
		obj.setUniqueid((rs.getObject(6) != null) ? new java.math.BigDecimal(rs
				.getObject(6).toString()) : null);
		obj.setOwner((rs.getObject(7) != null) ? new java.math.BigDecimal(rs
				.getObject(7).toString()) : null);
		obj.setModtime((rs.getObject(8) != null) ? new java.util.Date(
				((java.sql.Timestamp) rs.getObject(8)).getTime()) : null);
		obj.setModuser((rs.getObject(9) != null) ? new java.math.BigDecimal(rs
				.getObject(9).toString()) : null);
		obj.setDefaultvalue((String) rs.getObject(10));
		obj.setNullable((Boolean) rs.getObject(11));
		obj
				.setScorelevel((rs.getObject(12) != null) ? new java.math.BigDecimal(
						rs.getObject(12).toString())
						: null);
		obj
				.setParentasid((rs.getObject(13) != null) ? new java.math.BigDecimal(
						rs.getObject(13).toString())
						: null);
		obj.setParentscore((String) rs.getObject(14));
		obj.setAssessmentontology((String) rs.getObject(15));
		obj.setAssessmentconcept((String) rs.getObject(16));
		obj.setSecurityclassification((String) rs.getObject(17));
		obj
				.setMinanswers((rs.getObject(18) != null) ? new java.math.BigDecimal(
						rs.getObject(18).toString())
						: null);
		obj
				.setMaxanswers((rs.getObject(19) != null) ? new java.math.BigDecimal(
						rs.getObject(19).toString())
						: null);
		obj.setIsrequired((Boolean) rs.getObject(20));
		obj.setIsexcluded((Boolean) rs.getObject(21));
		obj.setIsnew((Boolean) rs.getObject(22));
		obj.setIsmodified((Boolean) rs.getObject(23));
		obj.setDescription((String) rs.getObject(24));
		return obj;
	}

	public List<Assessmentscore> find(Connection con, Assessmentscore criteria)
			throws Exception {

		PreparedStatement ps = null;
		ResultSet rs = null;
		List<Assessmentscore> results = new LinkedList<Assessmentscore>();
		StringBuffer buf = new StringBuffer(200);

		if (criteria == null)
			return null;
		buf.append("SELECT ");
		buf.append(prepareColList(criteria));
		buf.append(" FROM nc_assessmentscore ");
		QueryInfo qi = prepareWhereClause(criteria);
		buf.append(qi.whereClause);
		try {
			ps = con.prepareStatement(buf.toString());
			ps.clearParameters();
			int i = 0;
			for (Iterator<?> it = qi.values.iterator(); it.hasNext();) {
				ps.setObject(++i, it.next());
			}
			rs = ps.executeQuery();
			while (rs.next()) {
				Assessmentscore item = createObject(rs);
				results.add(item);
			}
		} finally {
			DBUtils.close(ps, rs);
		}
		return results;
	}

	public void update(Connection con, Assessmentscore bean,
			Assessmentscore criteria) throws Exception {
		PreparedStatement ps = null;

		if (bean == null)
			return;

		UpdateQueryInfo uqi = prepareUpdateQuery(bean, criteria);
		try {
			ps = con.prepareStatement(uqi.query);
			ps.clearParameters();
			int i = 0;
			Iterator<Integer> it2 = uqi.sqlTypes.iterator();
			Iterator<Boolean> it3 = uqi.nullSetList.iterator();
			for (Iterator<?> it = uqi.setValues.iterator(); it.hasNext();) {
				Object value = it.next();
				Integer sqlType = (Integer) it2.next();
				boolean nullSet = ((Boolean) it3.next()).booleanValue();
				if (nullSet) {
					ps.setNull(++i, sqlType.intValue());
				} else {
					ps.setObject(++i, value);
				}
			}
			// for where part
			for (Iterator<?> it = uqi.whereValues.iterator(); it.hasNext();) {
				ps.setObject(++i, it.next());
			}
			ps.executeUpdate();
		} finally {
			DBUtils.close(ps);
		}
	}

	public void delete(Connection con, Assessmentscore criteria)
			throws Exception {
		PreparedStatement ps = null;
		StringBuffer buf = new StringBuffer(200);
		buf.append("DELETE FROM nc_assessmentscore ");

		QueryInfo qi = prepareWhereClause(criteria);
		buf.append(qi.whereClause);
		try {
			ps = con.prepareStatement(buf.toString());
			ps.clearParameters();
			int i = 0;
			for (Iterator<?> it = qi.values.iterator(); it.hasNext();) {
				ps.setObject(++i, it.next());
			}
			ps.executeUpdate();

		} finally {
			DBUtils.close(ps);
		}
	}

	public static class QueryInfo {
		String whereClause;
		List<? super Object> values = new LinkedList<Object>();

		public QueryInfo() {
		}

		public QueryInfo(String whereClause) {
			this.whereClause = whereClause;
		}
	}

	public static class UpdateQueryInfo {
		String query;
		List<? super Object> setValues = new LinkedList<Object>();
		List<Integer> sqlTypes = new LinkedList<Integer>();
		List<Boolean> nullSetList = new LinkedList<Boolean>();
		List<? super Object> whereValues = new LinkedList<Object>();

		public UpdateQueryInfo() {
		}
	}

	/* +++ */
	// Enter your code here
	/* +++ */
}// ;
