package clinical.web;

/**
 * 
 * @author I. Burak Ozyurt
 * @version $Id: CBFBIRNConstants.java 806 2013-05-06 23:25:04Z bozyurt $
 */
public class CBFBIRNConstants {
	private CBFBIRNConstants() {}
	
	public final static String ANAT_SERIES_DESC1 = "FSPGR_SAG_TI450";
	public final static String ANAT_SERIES_DESC2 = "FSPGR_ASSET_SAG_TI600";
	public final static String ANAT_SERIES_DESC3 = "FSPGR_SAG_TI600";
	public final static String ANAT_SERIES_DESC4 = "FSPGR_SAG_TI550";

	public final static String TOF_SERIES_DESC = "3D TOF";
	public final static String FM_TE1_DESC = "fm_TE1_NFS";
	public final static String FM_TE2_DESC = "fm_TE2_NFS";
	public final static String FM_GRASS_DESC = "fm_grass_64x64";
	public final static String LOCALIZER_DESC = "loc";

	public final static String DCM_SERIES_DESC_FIELD = "SeriesDescription";

	public final static String MINCON = "Mincon";
	public final static String CSF = "CSF";
	public final static String EPISTAR = "EPISTAR";
	public final static String FAIR = "FAIR";
	public final static String PICORE = "PICORE";
	public final static String VSASL = "VSASL";
	public final static String CASL = "CASL";
	public final static String PCASL = "PCASL";
	public final static String PCASL_4MP = "4MP-PCASL";
	public final static String PCASL_8MP = "8MP-PCASL";
	public final static String Opt_PCASL = "Opt-PCASL";
	public final static String Opt_PCASL_Calib = "Opt-PCASL-Calib";
	public final static String PCASL_4MP_or_Opt_PCASL_Calib = "4MP-PCASL or Opt-PCASL-Calib";
	public final static String PCASL_VARIANT = "PCASL Variant";
	public final static String ANATOMICAL = "Anatomical";
	public final static String TOF = "TOF";
	public static final String LOCALIZER = "Localizer";
	public static final String DTI = "DTI";
	public static final String PCASL_EP2D_UCLA = "PCASL_EP2D_UCLA";
	public static final String D3PCASL = "3DPCASL";

	// public final static String FIELDMAP = "Field Map";
	public final static String FIELD_MAP = "Field Map";
	
	public final static String OPT_PCASL = "Opt-PCASL";
	public final static String OPT_PCASL_CALIB = "Opt-PCASL-Calib";
	public static final String SIEMENS = "Siemens";

	public final static String EPISTAR_CSF = "EPISTAR+CSF";
	public final static String FAIR_CSF = "FAIR+CSF";
	public final static String PICORE_CSF = "PICORE+CSF";
	public final static String VSASL_CSF = "VSASL+CSF";
	public final static String CASL_CSF = "CASL+CSF";
	public final static String PCASL_CSF = "PCASL+CSF";
	public final static String PCASL_4MP_CSF = "4MP-PCASL+CSF";
	public final static String PCASL_8MP_CSF = "8MP-PCASL+CSF";
	public final static String Opt_PCASL_CSF = "Opt-PCASL+CSF";
	public final static String Opt_PCASL_Calib_CSF = "Opt-PCASL-Calib+CSF";
	public final static String PCASL_4MP_or_Opt_PCASL_Calib_CSF = "4MP-PCASL or Opt-PCASL-Calib+CSF";
	public final static String PCASL_VARIANT_CSF = "PCASL Variant+CSF";
	// public final static String PCASL_4MP_OR_OPT_PCASL_CALIB_CSF =
	// "4MP-PCASL or Opt-PCASL-Calib+CSF";
	public final static String OPT_PCASL_CSF = "Opt-PCASL+CSF";
	public final static String OPT_PCASL_CALIB_CSF = "Opt-PCASL-Calib+CSF";

	public final static String[] EMBEDDED_CSF_ASL_SERIES_ARR = { EPISTAR_CSF,
			FAIR_CSF, PICORE_CSF, VSASL_CSF, CASL_CSF, PCASL_CSF,
			PCASL_4MP_CSF, PCASL_8MP_CSF, Opt_PCASL_CSF, Opt_PCASL_Calib_CSF,
			PCASL_4MP_or_Opt_PCASL_Calib_CSF, PCASL_VARIANT_CSF, OPT_PCASL_CSF,
			OPT_PCASL_CALIB_CSF };

	public static final String CBF_PROCESSING_WORKFLOW = "CBF Processing Workflow";
	public static final String CBF_ROI_ANALYSIS = "CBF ROI Group Analysis";
	public static final String CBF_STANDARD_SPACE_ANALYSIS = "CBF Standard Space Analysis";
	public static final String CBF_BASELINE_GROUP_ANALYSIS = "CBF Baseline Group Analysis";
	

	public static final String SENSE_PREFIX = "sense_";
	public static final String DERIVED = "derived";

	public final static String KEY_FIELDMAP = "fieldmap";
	public final static String KEY_SENSE = "sense";
	public final static String KEY_SMOOTHING = "smoothingParam";
	public final static String KEY_FABBER = "fabber";
	public final static String FIELDMAP_BRIK_PATTERN = "+dbl";
	public final static String SENSE_BRIK_PATTERN = "sense_";

	public final static String AFNI_DIR_NAME = "afni";
	public final static String AFNI_TYPE = "afni";
	
	public final static String ANALYZE_DIR_NAME = "analyze";
	
	public final static String CSF_TCAT_BRIK_PREFIX = "csfbriktcat+orig";
	public final static String TCAT_PATTERN = "tcat+orig";
	
	public final static String INTERMEDIATE = "intermediate";
	public final static String CBFHIST_IMG = "cbfhist.png";
	public final static String CBFMAP_IMG = "cbfmap.png";
	public final static String MOTION_IMG = "motion.png";
	public final static String CSF_MASKS_IMG = "csf_masks.png";
	public final static String CSF_SLICES_IMG = "csf_slices.png";
	
	public final static String CSF_MAP_PV_IMG = "csfmap_pv.png";
	public final static String CSF_MAP_TOP5_IMG = "csfmap_top5.png";
	public final static String CSF_ROI_PV_IMG = "csf_roi_pv.png";
	public final static String CSF_ROI_TOP5_IMG = "csf_roi_top5.png";
	
	public final static String FMRI_STRUCT_MAT_FILE = "fmri_struct.mat";
	public static final Object CBF_SUMMARY_FILE = "cbfbirn_path1_summary.txt";
	
	// Quality Measure Provenance Labels
	public static final String CBF_PROC_QUALITY_RATING_NAME = "cbfProcRating";
	public static final String CBF_PROC_QUALITY_REASONS_NAME = "cbfProcRatingReasons";
	public static final String CBF_PROC_QUALITY_COMMENT_NAME = "cbfProcRatingComment";
	public static final String SEG_QUALITY_RATING_NAME = "segmentationRating";
	public static final String SEG_QUALITY_REASONS_NAME = "segmentationRatingReasons";
	// provenance param labels
	public static final String PROV_FINISH_DATE = "Finish Date";
	
	
	// public static final String MATLAB_EXEC = "/apps/matlabr2011a/bin/matlab"; // original 
	
	public static final String MATLAB_EXEC = "/apps/matlabr2012b/bin/matlab";
	
	
	//public static final String MATLAB_EXEC = "/usr/local/bin/matlab";
	
	
}
