package clinical.web;

import java.sql.Connection;
import java.util.List;

import clinical.server.vo.Deriveddata;
import clinical.web.common.UserInfo;
import clinical.web.vo.DerivedDataInfo;
import clinical.web.vo.JobProvenanceInfo;

/**
 * @author I. Burak Ozyurt
 * @version $Id: IDerivedImageDataService.java 366 2011-05-05 20:06:27Z bozyurt
 *          $
 */
public interface IDerivedImageDataService {

	/**
	 * 
	 * @param ui
	 * @param ddiList
	 * @return
	 * @throws Exception
	 */
	public List<Deriveddata> addDerivedData(UserInfo ui,
			List<DerivedDataInfo> ddiList) throws Exception;

	/**
	 * 
	 * @param ui
	 * @param subjectID
	 * @param expID
	 * @param visitID
	 * @param segmentID
	 * @return
	 * @throws Exception
	 */
	public List<Deriveddata> findDerivedData(UserInfo ui, String subjectID,
			Integer expID, Integer visitID, Integer segmentID) throws Exception;

	public List<Deriveddata> findDerivedData(UserInfo ui, String subjectID,
			String expName, Integer visitID, Integer segmentID)
			throws Exception;

	public List<Deriveddata> addDerivedData(Connection con, UserInfo ui,
			List<DerivedDataInfo> ddiList) throws Exception;

	public List<Deriveddata> findDerivedData(UserInfo ui, String subjectID,
			Integer expID, Integer visitID, Integer segmentID, String fileType)
			throws Exception;

	public List<Deriveddata> findDerivedData(UserInfo ui, String subjectID,
			String expName, Integer visitID, Integer segmentID, String fileType)
			throws Exception;

	public void removeDerivedData(UserInfo ui, String subjectID, Integer expID,
			Integer visitID, Integer segmentID) throws Exception;

	public void removeDerivedData(UserInfo ui, String subjectID,
			String expName, Integer visitID, Integer segmentID)
			throws Exception;

	public void removeDerivedData(Connection con, String subjectID,
			Integer expID, Integer visitID, Integer segmentID) throws Exception;

	public void removeDerivedData(UserInfo ui, String subjectID, Integer expID,
			Integer visitID, Integer segmentID, String pathPrefix)
			throws Exception;

	public List<Deriveddata> addDerivedDataWithJobProvenance(UserInfo ui,
			List<DerivedDataInfo> ddiList, JobProvenanceInfo jpi)
			throws Exception;
}