package clinical.web;

import java.sql.Connection;
import java.util.List;

import clinical.server.VisitInfo;

/**
 * 
 * @author I. Burak Ozyurt
 * @version $Id: ISubjectVisitHandler.java 366 2011-05-05 20:06:27Z bozyurt $
 */
public interface ISubjectVisitHandler {
	/**
	 * 
	 * @param con
	 *            database connection
	 * @param subjectID
	 *            the BIRN ID of the subject to retrieve his/her visits
	 * @return a list of VisitInfo container objects
	 * @see clinical.server.VisitInfo
	 * @throws Exception
	 */
	public List<VisitInfo> getVisitInfos(String dbID, Connection con,
			String subjectID) throws Exception;

	// @param availableTables map used to figure out which face of the visit
	// table to use
}