package clinical.web.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import clinical.web.Constants;

/**
 *
 * @author I. Burak Ozyurt
 * @version $Id: CADispatcherAction.java 366 2011-05-05 20:06:27Z bozyurt $
 */
public class CADispatcherAction
    extends BaseAction {
  private Log log = LogFactory.getLog(CADispatcherAction.class);

  public CADispatcherAction() {
  }

  public ActionForward execute(ActionMapping mapping, ActionForm form,
      HttpServletRequest request, HttpServletResponse response) throws
      Exception {
    try {
      getUserInfo(request);
      HttpSession session = request.getSession(false);
      String formBeanName = (String) session
          .getAttribute(Constants.GAME_FORM_BEAN_NAME_KEY);

      if (formBeanName == null) {
        throw new Exception("No form bean is set!");
      }
      log.info("formBeanName=" + formBeanName);
      session.removeAttribute(Constants.GAME_FORM_BEAN_NAME_KEY);
      if (formBeanName.equals("asiForm")) {
        return mapping.findForward(Constants.TO_ASI);
      } else if (formBeanName.equals("bdiForm")) {
        return mapping.findForward(Constants.TO_BDI);
//      } else if (formBeanName.equals("test1Form")) {
//        return mapping.findForward(Constants.TO_TEST1);
      } else if (formBeanName.equals("barsForm")) {
        return mapping.findForward(Constants.TO_BARS);
      } else if (formBeanName.equals("sansForm")) {
        return mapping.findForward(Constants.TO_SANS);
      } else if (formBeanName.equals("cdsForm")) {
        return mapping.findForward(Constants.TO_CDS);
      } else if (formBeanName.equals("aimsForm")) {
        return mapping.findForward(Constants.TO_AIMS);
      } else if (formBeanName.equals("sapsForm")) {
        return mapping.findForward(Constants.TO_SAPS);
      } else if (formBeanName.equals("sarsForm")) {
        return mapping.findForward(Constants.TO_SARS);
      } else if (formBeanName.equals("figsForm")) {
        return mapping.findForward(Constants.TO_FIGS);
      } else if (formBeanName.equals("pasForm")) {
        return mapping.findForward(Constants.TO_PAS);
    //  } else if (formBeanName.equals("testForm")) {
      } else if (formBeanName.equals("sesForm")) {
        return mapping.findForward(Constants.TO_SES);
      } else if (formBeanName.equals("naartForm")) {
        return mapping.findForward(Constants.TO_NAART);
      } else if (formBeanName.equals("dssForm")) {
        return mapping.findForward(Constants.TO_DSS);
      } else if (formBeanName.equals("ehiForm")) {
        return mapping.findForward(Constants.TO_EHI);
      } else if (formBeanName.equals("panssForm")) {
        return mapping.findForward(Constants.TO_PANSS);
      } else if (formBeanName.equals("scid_pForm")) {
        return mapping.findForward(Constants.TO_SCIDP);
      } else if (formBeanName.equals("scid_npForm")) {
        return mapping.findForward(Constants.TO_SCIDNP);
      } else if (formBeanName.equals("ctaForm")) {
        return mapping.findForward(Constants.TO_CTA);
      } else if (formBeanName.equals("interseptForm")) {
        return mapping.findForward(Constants.TO_INTERSEPT);
      } else if (formBeanName.equals("testmaForm")) {
        return mapping.findForward(Constants.TO_TESTMA);
      } else if (formBeanName.equals("favoritesForm")) {
        return mapping.findForward(Constants.TO_FAVORITES);
      } else if (formBeanName.equals("hairstyleForm")) {
        return mapping.findForward(Constants.TO_HAIRSTYLE);
      } else if (formBeanName.equals("hallucinationForm")) {
        return mapping.findForward(Constants.TO_HALLUCINATION);
      } else if ( formBeanName.equals("demographicsForm")) {
        return mapping.findForward(Constants.TO_DEMOGRAPHICS);
      } else if ( formBeanName.equals("ageofonsetForm")) {
    	  return mapping.findForward(Constants.TO_AGEOFONSET);
      } else if ( formBeanName.equals("packyearForm")) {
    	  return mapping.findForward(Constants.TO_PACKYEAR);
      } else if ( formBeanName.equals("travelscreenForm")) {
    	  return mapping.findForward(Constants.TO_TRAVELSCREEN);
      } else if ( formBeanName.equals("hfForm")) {
    	  return mapping.findForward(Constants.TO_HEMATOCRIT);
      } else if ( formBeanName.equals("scid_p_mForm")) {
          return mapping.findForward(Constants.TO_SCID_P_M);
      } else if ( formBeanName.equals("quickmoodForm")) {
          return mapping.findForward(Constants.TO_QUICKMOOD);
      } else if ( formBeanName.equals("hematocritForm")) {
          return mapping.findForward(Constants.TO_HEMATOCRIT);
      } else if ( formBeanName.equals("htcaForm")) {
          return mapping.findForward(Constants.TO_HTCA);
      } else if ( formBeanName.equals("hcaForm")) {
          return mapping.findForward(Constants.TO_HCA);
      } else if ( formBeanName.equals("ftcaForm")) {
          return mapping.findForward(Constants.TO_FTCA);
      } else if ( formBeanName.equals("qmstForm")) {
          return mapping.findForward(Constants.TO_QMST);
      } else if ( formBeanName.equals("ses1Form")) {
          return mapping.findForward(Constants.TO_SES1);
      } else if ( formBeanName.equals("demographForm")) {
          return mapping.findForward(Constants.TO_DEMOGRAPH);
      } else {
        throw new Exception("Not a recognized form bean: "
                            + formBeanName);
      }

    } catch (Exception x) {
      log.error("CADispatcherAction", x);
      return processExceptions(request, response, mapping, form, x);
    }
  }

}
