package clinical.web.services;

import java.util.List;
import java.util.Set;

import clinical.server.vo.Experiment;
import clinical.server.vo.GroupAnalysisData;
import clinical.web.common.UserInfo;
import clinical.web.common.vo.GroupCBFReportRec;
import clinical.web.vo.CBFROIJobAssociation.JobVisitInfo;
import clinical.web.vo.FactorRepeatedMeasureInfo;

public interface IGroupCBFReportQueryService {

	public List<GroupCBFReportRec> getGroupCBFRecords(final UserInfo ui,
			final List<Experiment> allowedExps, Set<String> includedJobTypeSet) throws Exception;

	public List<FactorRepeatedMeasureInfo> getEligibleFactors(
			final UserInfo ui, final List<JobVisitInfo> jviList)
			throws Exception;

	public List<GroupAnalysisData> getGroupAnalysisDerivedData(
			final UserInfo ui, final String jobID) throws Exception;

}