package clinical.web.services;

/**
 * Interface to be implemented by services that needs to be run periodically in
 * the background to be registered with {@link PeriodicServiceManagementService}
 * .
 * 
 * @author I. Burak Ozyurt
 * @version $Id$
 */
public interface IPeriodicService {
	/**
	 * returns repetition interval in millisecs at which the service will be
	 * called
	 * 
	 * @return
	 */
	public long getPeriod();

	/**
	 * handler for the service provided.
	 * 
	 * @throws Exception
	 */
	public void service() throws Exception;
}
