package clinical.web.tags.sec;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import clinical.web.Constants;
import clinical.web.UserContainer;

/**
 * 
 * @author I. Burak Ozyurt
 * @version $Id: CanNotContinueTag.java 366 2011-05-05 20:06:27Z bozyurt $
 */
public class CanNotContinueTag extends TagSupport {
	private static final long serialVersionUID = 5197197024650549630L;

	public int doStartTag() throws JspException
	{
		HttpServletRequest req = (HttpServletRequest) pageContext.getRequest();
		HttpSession session = req.getSession(false);
		// JspWriter out = pageContext.getOut();
		if (session == null)
			return EVAL_BODY_INCLUDE;
		// check if there is a user container in the session (set after login
		// only)
		UserContainer userCon = (UserContainer) session
				.getAttribute(Constants.CONTAINER_KEY);
		if (userCon == null)
			return EVAL_BODY_INCLUDE;
		return SKIP_BODY;

	}
}
