package clinical.xml.ws;

import javax.jws.WebParam;
import javax.jws.WebService;

/**
 *
 * @author I. Burak Ozyurt
 * @version $Id: DataServices.java 91 2009-08-17 23:38:26Z bozyurt $
 */

@WebService(name = "dataServices")
public interface DataServices {
	public String getExperiments(@WebParam(name = "webUser")
	String webUser, @WebParam(name = "pwd")
	String pwd) throws Exception;

	public String getExperimentSubjects(@WebParam(name = "webUser")
	String webUser, @WebParam(name = "pwd")
	String pwd) throws Exception;

	public String getSubjects4Experiment(@WebParam(name = "webUser")
	String webUser, @WebParam(name = "pwd")
	String pwd, @WebParam(name = "expName")
	String expName) throws Exception;

	/**
	 * This method supports a very simple attribute-value based query language.
	 * An example of this language is given below;
	 *
	 * <pre>
	 *    subjectID={value} and expName={value} and fileType={value}
	 * </pre>
	 *
	 * The attributes supported are
	 * <ul>
	 * <li>subjectID</li>
	 * <li>expName</li>
	 * <li>fileType</li>
	 * </ul>
	 * Also the special value '*' is supported as don't care symbol.
	 *
	 * @param query
	 *            query string
	 * @return
	 */
	public String searchDD(@WebParam(name = "webUser")
	String webUser, @WebParam(name = "pwd")
	String pwd, @WebParam(name = "query")
	String query)  throws Exception;
}
