<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core" %>

<style>
.acb {
  margin-bottom:0.5em;
}

#autoCompleteMenu ul {
  width: 30em;
}

.select-style {
   padding: 5px;
   font-size: 16px;
   border: 1px solid #ccc;
}
</style>

<script type="text/javascript">
  var helpSystem = null;
  window.addOnLoadListener(onLoadHandler);
  
  function onLoadHandler() {
    var options = [];
    var url = '<html:rewrite page="/help.do?context=as_query"/>';
    helpSystem = new bal.AjaxHelpSystem(url, options);
  }
  
</script>
  
<div class="error">
<html:errors/>
</div>

<br>

<script language='javascript'>
  function query(elem) {
     elem.form.actionParam.value='query';
     elem.form.submit();
     return false;
  }
  
  function msQuery(elem) {
     elem.form.actionParam.value='msQuery';
     elem.form.submit();
     return false;   
  }
  
  function changeTab(form) {
     alert('changeTab: form:' + form);
     if (form) {
        form.submit();
     }		
     return false;	   
  }
  
  jQuery(function() {
    jQuery('#asTab').click(function(event) { 
         return jQuery.changeTab(jQuery('#qtf')[0]); 
    });
    jQuery('#gaTab').click(function(event) { 
         return jQuery.changeTab(jQuery('#garf')[0]); 
    });
    jQuery('#queryBot').click(function(event) { return jQuery.submitQuery(this,'query');});

    jQuery('#reportExpSel').dblclick(function(evt) {
        return jQuery.submitQuery(this,'query');
    });
  });
</script>
<html:form action="/caquery" styleId="qtf">
<input type="hidden" name="actionParam" value="Show"/>
</html:form>

<html:form action="/gareportquery" styleId="garf">
<input type="hidden" name="actionParam" value="Show"/>
</html:form>

<div id="tabpanel">
   <ul id="tabs">  
        <c:if test="${asSelectForm.supportAssessmentQuery}">
          <li><a href='javascript:{}' onclick="changeTab(jQuery('#qtf')[0])">Assessment</a></li>
        </c:if>
       <c:if test="${asSelectForm.supportAnalysisQuery}">
           <li><a href='javascript:{}' onclick="changeTab(jQuery('#aqtf')[0]);">Analysis</a></li>
       </c:if>
       <li class="activelink"><a href='#' >Reports</a></li>      
       <li><a id='gaTab' href=''>Group Analyses</a></li>   
   </ul>
</div>
<html:form styleId="cprqForm" action="/cbfreportquery" onsubmit="return false">
<input type="hidden" name="actionParam" value="query"/>
<input type="hidden" name="queryString" value=""/>
<div id="qb_wizard" >
   <div style="text-align:left; padding:0; margin:0; background-color:#ffcc33;  line-height:1.8em; ">
     <span class="mlarge" style="margin:5px;">Report Builder</span><br>
   </div>
    
   <div style="margin:1em; line-height:1.6em; vertical-align:middle;">
	   <bean:define id="expIDList" name="asSelectForm" property="reportExpSelector.experimentInfos"
          type="java.util.Collection"/>
	     <div style="padding-bottom:5px;">
           <span class="msmall" style="margin-left:5px;" >Experiment(s):</span>&nbsp;
           <html:select styleId="reportExpSel" name="asSelectForm" property="reportExpSelector.selectedExpIDs" multiple="true" size="5">
             <html:options collection="expIDList" property="value" labelProperty="label"/>
           </html:select>
         </div>
         <div style="margin-left:5px;">
           A range of experiments/projects can be selected by pressing and holding down Shift key on your keyboard while selecting with the mouse.<br></br>
           Multiple non-contiguous experiments can be selected by pressing and holding down Ctrl key on your keyboard while selecting with the mouse.
         </div>
   </div>
     <div style="padding:1em;">
   </div>
   
   <div style="text-align: right; ">
     <c:if test="${stateCoordinator.hasMultipleDatabases}">
       <input type="button" id='msQueryBut' class="submit-button" onclick="return msQuery(this);" value="Multi-site Query"></input>&nbsp;            
     </c:if>
     <input type="button" id='queryBot' class="submit-button" value="Query"></input>          
   </div>
</div>

</html:form>

<script>
     var divElem = jQuery('#qb_wizard')[0];
     var options = {color: "#ffcc33", corners: 'top'};
     Rico.Corner.round( divElem, options );
     Rico.Corner.round( divElem,  {color: "#d3d3d3", corners: 'bottom'});
     var tabs = jQuery('#tabs li');
     tabs.each(
         function() { 
            Rico.Corner.round( jQuery(this)[0],  {color: "#00659c", corners: 'top'}); }
      );
     
</script>
