<%@ page contentType="text/html;charset=UTF-8" language="java"%>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean"%>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html"%>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic"%>
<%@ taglib uri="/WEB-INF/clinical.tld" prefix="birn"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core"%>

<link rel=stylesheet
	href="<%=request.getContextPath()%>/pages/layout/jt_DialogBox.css"
	type="text/css">

<script src="<%=request.getContextPath()%>/pages/dom-drag.js" type="text/javascript"></script>
<script src="<%=request.getContextPath()%>/pages/jt_DialogBox.js" type="text/javascript"></script>
<script src="<%=request.getContextPath()%>/pages/jt_AppDialogs.js" type="text/javascript"></script>
<script src="<%=request.getContextPath()%>/pages/DDPrompt.js" type="text/javascript"></script>


<script type='text/javascript'>
   var dialogBox = null;
   var aPromptBox = null;
   var linkElem = null;

   function okButtonHandler(returnData) {
       if ( returnData) {
         var st = linkElem.href;
         var fe = document.getElementById('subjectVisitSubmitForm');
         var subjectID = '';
         if ( st.match(/sid=(\w+)/) ) {
            subjectID = RegExp.$1;  
         }
         go2SubjectVisitDetail(subjectID, returnData.value);
       }
   }

   function go2SubjectVisitDetail(subjectID, siteID) {
      var fe = document.getElementById('subjectVisitSubmitForm');
      var he1 = createHiddenField('sid', subjectID);
      fe.appendChild(he1); 
      var he2 = createHiddenField('siteid', siteID);
      fe.appendChild(he2);
      fe.submit();
   }

   function createHiddenField(name, value) {
      var he = document.createElement('input');
      he.type = 'hidden';
      he.name= name;
      he.value = value;
      return he;
   }

   function siteSelect(ev, elem, siteIDListStr) {
      var e = jt_fixE(ev);
      var siteIDs = siteIDListStr.split(',');
      if ( siteIDs.length > 1) {
          jt_DialogBox.imagePath = 'images/';
          linkElem = elem;
  
          if ( aPromptBox == null) {
              aPromptBox = new hid_DDPrompt(null, okButtonHandler, null, siteIDs);
              aPromptBox.setTitle('Select a Site:');
          }
          aPromptBox.moveTo(e.clientX, e.clientY + document.body.scrollTop);
          //aPromptBox.moveTo(-1, -1); // centers dialog in window!
          aPromptBox.askUser('<div style="padding:0px 5px 10px 0px;">Please select a site:</div>');
          aPromptBox.focus(); // required for IE
          return false;
      } else {          
         return true;
      }	   
   }
	
	function dbOkButtonHandler(returnData) {
		var comps = returnData.comps;
		var elem = returnData.elem;
		
		for(var i = 0; i < comps.length; i++) {
			var elems = comps[i].elems;
			var paramName = null;
			if (comps[i].title == 'Format')
				paramName = "formatOption";
			else if (comps[i].title == 'Content') 
				paramName = "contentOption";
			for(var j = 0; j < elems.length; j++) {
				if (elems[j].checked) {
					if (paramName) {
						var hf = utils.createHiddenField(paramName, elems[j].value);
						elem.form.appendChild(hf);
					}
				} else {
				   if (paramName && comps[i].type == 'cb') {
						var hf = utils.createHiddenField(paramName, 'none');
						elem.form.appendChild(hf);
					}
				}
			}			
		}
		elem.form.action.value='Export CSV';
		elem.form.submit();
		return false;
	}
	
	function exportCSV(ev, elem) {
		var e = jt_fixE(ev);
		jt_DialogBox.imagePath = 'images/';
		if (!dialogBox) {
			var dialogOpts = {comps : [{type: 'radio', title:'Format', 
				elems: [{name:'_format', label : 'A Segment Per Line', value:'segment', checked:true},
				{name:'_format', label : 'A Visit Per Line', value:'visit', checked:false}]},
				  {type:'cb', title:'Content', 
					elems: [{name:'_content', label : 'Include Derived Data', value:'includeDD', checked:true}]}]};
			dialogOpts.elem = elem;
			dialogBox = new hid_DialogBox(null, dbOkButtonHandler, null, dialogOpts);
			dialogBox.setTitle("CSV Report Options");
		}
		dialogBox.moveTo(e.clientX, e.clientY + document.body.scrollTop);
      dialogBox.askUser();
      dialogBox.focus();
		
		return false;
	}
   
   function scStatusHandler(itemCount) {
       // alert('in scStatusHandler: itemCount:' + itemCount);
       var el = document.getElementById('viewSCSpan');
       if ( el) {
          if (itemCount && itemCount > 0) {
            el.style.color = 'white';
            el.style.fontWeight = 'bold';
            if ( itemCount == 1) {
              el.innerHTML=  itemCount + " item";
            } else {
              el.innerHTML=  itemCount + " items";
            }
          } else {
             el.innerHTML = '';
          }
       }
   }
   
   function go(elem, actionValue) {
     elem.form.action.value =actionValue;
   }
   
   function goBlock(elem, actionValue) {
     elem.form.action.value =actionValue;
     // jQuery.blockUI( { message: '<h1>Just a moment..</h1>'} );
   }
   
   function go2(elem, actionValue) {
     elem.form.action.value =actionValue;
     elem.form.submit();
     return false;
   }
   
   function go3(elem, actionValue, contextValue) {
     elem.form.action.value =actionValue;
     elem.form.context.value=contextValue
     elem.form.submit();
     return false;
   }
   
   function unloadHandler() {
      // jQuery.unblockUI();  
   }
   
   var helpSystem = null;
   var shoppingCart = null;
   
   function onLoadHandler() {

      var options = [];
      var url = '<html:rewrite page="/help.do?context=sv_results"/>';
      helpSystem = new bal.AjaxHelpSystem(url, options); 
      var scUrl = '<html:rewrite page="/cart.do?action=addItem"/>';
      shoppingCart = new sc.AjaxShoppingCart(scUrl, options);
      shoppingCart.addListener(scStatusHandler);  
      var scCountUrl =  '<html:rewrite page="/cart.do?action=checkCounts"/>';
      shoppingCart.checkItemCount(scCountUrl);   
   }

   window.addOnLoadListener(onLoadHandler);  
  //  window.onunload=unloadHandler;
   
</script>

<style>
  #svresults_pane {
   float:left;
   width:90%; 
}
</style>

<div class="error"><html:errors /></div>

<html:form action="/subvisit"
	styleId="subjectVisitSubmitForm">
</html:form> 

<html:form action="/svresults">
	<input type="hidden" name="action" value="" />
	<input type="hidden" name="context" value="" />

<div id="svresults_pane">
	<table border="0" cellspacing="0" bgcolor="#d3d3d3" class="tablelist">
		<c:if test="${asSelectForm.qsSearchResultsIter.size == 0}">
			<h4 class="warn"><bean:message key="msg.noqresults" /></h4>
		</c:if>

		<c:if test="${asSelectForm.qsSearchResultsIter.size > 0}">
			<tr bgcolor="#00659c" style="vertical-align: middle;">
				<td align="left" colspan="3">
				<table border='0' width='100%'>
					<tr>
						<td><%-- <span id="af_group"> --%> <html:submit
							styleClass="submit-button" styleId="exploreDataBut"
							onclick="go(this,'Explore Data')">
							<bean:message key="button.show.stats.input" />
						</html:submit> <span id="help_7"> <input type="image"
							src="<%=request.getContextPath()%>/pages/images/questionmark2a.png" border="0"
							style="vertical-align: bottom; margin-bottom: 3px;"
							onclick="return helpHandler('help_7')"> </span> &nbsp; <html:submit
							styleClass="submit-button" styleId="batchQueryBut"
							onclick="goBlock(this,'Batch Query')">
							<bean:message key="button.batch.query" />
						</html:submit> <span id="help_8"> <input type="image"
							src="<%=request.getContextPath()%>/pages/images/questionmark2a.png" border=0
							style="vertical-align: bottom; margin-bottom: 3px;"
							onclick="return helpHandler('help_8')"> </span> &nbsp; <html:submit
							styleClass="submit-button" styleId="export_csv"
							onclick="return exportCSV(event,this);">
							<bean:message key="button.csv" />
						</html:submit> &nbsp; <html:submit styleClass="submit-button"
							styleId="export_csv" onclick="go(this,'Batch Download')">
							<bean:message key="button.sc.showbatch" />
						</html:submit></td>
						<td align="right">&nbsp;
						<div id="viewSC">
						<button onclick="return go3(this,'viewCart','new');"><img
							src="<%=request.getContextPath()%>/pages/images/shopping_cart.png"></button>
						<span id="viewSCSpan"></span></div>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr bgcolor="#00659c" height="20">
				<td align="left" colspan="2">&nbsp;</td>
				<td align="right">&nbsp; <bean:define id="totalPages"
					name="asSelectForm" property="qsSearchResultsIter.numberOfWindows"
					type="java.lang.Integer" /> <bean:define id="curPage"
					name="asSelectForm" property="qsSearchResultsIter.currentWindow"
					type="java.lang.Integer" /> 
					<div id="mpNav">
					<birn:navigator baseLink="svresults.do"
					    cssClass="navigator" prevPageAttr="Prev" nextPageAttr="Next"
					pageAtAttr="pageAt" currentPage="<%= curPage %>"
					totalPages="<%= totalPages %>" />
					</div>
				</td>
			</tr>
			<tr bgcolor="#00659c" height="25">
				<td>&nbsp;</td>
				<td>&nbsp;</td>
				<td align="right"><span style="color: white; font-size: 11px;">
				Results <c:out
					value="${asSelectForm.qsSearchResultsIter.windowStartIdx}" />-<c:out
					value="${asSelectForm.qsSearchResultsIter.windowEndIdx}" /> of <c:out
					value="${asSelectForm.qsSearchResultsIter.size}" /></span> </font></td>
			</tr>

			<!-- header -->
			<tr bgcolor="#00659c">
				<td align="left"><span class="result_header"><bean:message
					key="header.svresults.subjectid" /></span></td>
				<td align="left"><span class="result_header">Site ID</span></td>

				<td>&nbsp;</td>
			</tr>

			<c:forEach var="summary"
				items="${asSelectForm.qsSearchResultsIter.currentWindowContents}" varStatus="qrLoopStatus">
				<tr bgcolor="#C0C0C0">
					<td align="left"><bean:define id="siteIDListStr"
						name="summary" property="allSiteIDs" />
					<div><a
						href='<html:rewrite action="subvisit" name="summary" property="paramMap"/>'
						onclick="return siteSelect(event, this,'<%=siteIDListStr%>');">
					<c:out value="${summary.subjectID}" /></a></div>
					<span style="color: maroon; font-weight: bold;">Experiment:
					</span><c:out value="${summary.expName}" /> &nbsp; &nbsp; <bean:define
						id="sb" name="summary" type="clinical.web.vo.QuerySummary" />
					<button
						onclick="shoppingCart.addItem(<%=sb.getParamJSON()%>); return false;">
					<img src="<%=request.getContextPath()%>/pages/images/2shoppingcart.png"></button>

					</td>
					<td><c:out value="${summary.siteID}" /></td>
					<td>
					<table border=0 width="100%" cellpadding="2">
						<c:forEach var="vsr" items="${summary.VSRWrapperList}">
							<tr>
								<c:choose>
									<c:when test="${not empty vsr.caVS}">
										<td align="left">
										<div><b>Visit:</b> <c:out value="${vsr.caVS.visitID}" />
										<b>Seg:</b> <c:out value="${vsr.caVS.segmentID}" /></div>
										<b>Date:</b> <c:out value="${vsr.caVS.timeStamp}" /></td>
									</c:when>
									<c:otherwise>
										<td align="left">
										<div><b>Visit:</b> <c:out value="${vsr.ddVS.visitID}" />
										<b>Seg:</b> <c:out value="${vsr.ddVS.segmentID}" /></div>
										<b>Date:</b> <c:out value="${vsr.ddVS.timeStamp}" /></td>
									</c:otherwise>
								</c:choose>
								<td><c:if test="${not empty vsr.caVS}">
									<div>
									<table border="0" width="100%" cellpadding="2">
										<c:forEach var="row" items="${vsr.caVS.rows}">
											<tr>
												<c:forEach var="vw" items="${row.columns}">
													<c:if test="${not vw.emptyObject}">
														<td colspan='<c:out value="${row.colSpan}"/>'><c:if
															test="${vw.key.title}">
															<span style="font-weight: bold;"><c:out
																value="${vw.key.asName}" /></span>
														</c:if> <c:if test="${not vw.key.title}">
															<c:out value="${vw.key.scoreName}" />: &nbsp;
						                                    <c:out value="${vw.value}" />
														</c:if></td>
													</c:if>
													<c:if test="${vw.emptyObject}">
														<td>&nbsp;</td>
													</c:if>
												</c:forEach>
											</tr>
										</c:forEach>
									</table>
									</div>
								</c:if> 
								<c:if test="${not empty vsr.ddVS}">
									<div>
									<table border="0" width="100%" cellpadding="2">
										<c:forEach var="row" items="${vsr.ddVS.rows}">
											<tr>
												<c:forEach var="vw" items="${row.columns}">
													<c:if test="${not vw.emptyObject}">
														<td colspan='<c:out value="${row.colSpan}"/>'><c:if
															test="${vw.key.title}">
															<span style="font-weight: bold;"><c:out
																value="${vw.key.extendedTupleName}" /></span>
														</c:if> <c:if test="${not vw.key.title}">
															<c:out value="${vw.key.mgName}" /> &nbsp;
						                                    <c:out value="${vw.key.fieldName}" />: &nbsp;
						                                    <c:out value="${vw.value}" />
														</c:if></td>
													</c:if>
													<c:if test="${vw.emptyObject}">
														<td>&nbsp;</td>
													</c:if>
												</c:forEach>
											</tr>
										</c:forEach>
									</table>
									</div>
								</c:if></td>
							</tr>					
						</c:forEach>
					</table>
					</td>			        
				</tr>
				<c:if test="${not qrLoopStatus.last}">
				<tr bgcolor="#c0c0c0"><td colspan="3">
				   <div style="border-bottom: 2px dotted #00659c; margin:0px;"/>
                                 </td></tr>
				</c:if>
			</c:forEach>
			<tr bgcolor="#00659c">
				<td><html:submit styleClass="submit-button"
					onclick="go(this,'Export CSV')">
					<bean:message key="button.csv" />
				</html:submit></td>
				<td>&nbsp;</td>
				<td align="right">&nbsp;</td>
			</tr>
		</c:if>

	</table>
 </div>	
</html:form>
