create or replace trigger nc_derivedData_insert
 AFTER INSERT ON NC_DERIVEDDATA
 FOR EACH ROW
begin
  INSERT INTO NC_RESEARCHDATA
    ( TABLEID, UNIQUEID, OWNER,MODTIME, MODUSER, ISBAD,                            
    EXTENSIONNAME, DATAURI, ISRAW, DATAONTOLOGY, DATACLASS) 
  VALUES(:new.TABLEID,
    :new.UNIQUEID,
    :new.OWNER,
    :new.MODTIME,
    :new.MODUSER, 
    :new.ISBAD,                            
    :new.EXTENSIONNAME,                     
    :new.DATAURI,                          
    :new.ISRAW,
    :new.ONTOLOGYSOURCE,
    :new.CONCEPTID);

end;
/

create or replace trigger nc_derivedData_update
 AFTER UPDATE ON NC_DERIVEDDATA
 FOR EACH ROW
begin
  UPDATE NC_RESEARCHDATA
    SET OWNER = :new.OWNER,
        MODTIME = :new.MODTIME,
        MODUSER = :new.MODUSER,
        EXTENSIONNAME = :new.EXTENSIONNAME,                     
        DATAURI = :new.DATAURI,                          
        ISRAW = :new.ISRAW,
        ISBAD = :new.ISBAD,
        DATAONTOLOGY = :new.ONTOLOGYSOURCE,                           
        DATACLASS = :new.CONCEPTID
    WHERE
      TABLEID = :new.TABLEID AND UNIQUEID = :new.UNIQUEID;   

end;
/

create or replace trigger nc_derivedData_delete
  AFTER DELETE ON NC_DERIVEDDATA
 FOR EACH ROW
begin
  DELETE FROM NC_RESEARCHDATA
  WHERE
    TABLEID = :old.TABLEID AND UNIQUEID = :old.UNIQUEID;

end;
/
