drop table nc_scorevalidator ;

create table nc_scorevalidator(
    uniqueid          bigint    not null,
    tableid           bigint    not null,
    owner             bigint    not null,
    modtime timestamp not null,
    moduser           bigint    not null,
    assessmentid      bigint,
    scorename         varchar(128),
    validatortable    bigint    not null,
    validatorid       bigint    not null,
    constraint nc_scorevalidator_pk primary key (uniqueid) ,
    constraint nc_scorevalidator_sk  unique (uniqueid, tableid) );

-- comment on column nc_scorevalidator.uniqueid is 'the uniqueid column is one of the 5 core columns (tableid, uniqueid, owner, modtime, moduser) in the database  taken together with the tableid column these two columns specify a global unique object/tuple identifier within the database.  this unique identifying pair is critical for the extended tuple interface, database access controls and time travel. the uniqueid also servers as the principal unique identifier within each core table.' ;

-- comment on column nc_scorevalidator.tableid is 'the table identifier for all data stored within this table.  in conjunction with a unique id creates a unique reference to all tuples within the database for tuple level access control.' ;

-- comment on column nc_scorevalidator.owner is 'the database user who who owns the selected tuple.  this could be the user who created the entry or the user who manages/oversees the user who entered the tuple.' ;

-- comment on column nc_scorevalidator.modtime is 'the modification time of the current entry (year to fraction(5)).' ;

-- comment on column nc_scorevalidator.moduser is 'the user who modified the current tuple entry.  this can be different than the owner; if the user is entering data for the owner or if a user edited a tuple.' ;

-- comment on column nc_scorevalidator.assessmentid is 'the uniqueid column is one of the 5 core columns (tableid, uniqueid, owner, modtime, moduser) in the database  taken together with the tableid column these two columns specify a global unique object/tuple identifier within the database.  this unique identifying pair is critical for the extended tuple interface, database access controls and time travel. the uniqueid also servers as the principal unique identifier within each core table.' ;

-- comment on column nc_scorevalidator.scorename is 'the name column is used to store the name of the object being described by the tuple. ' ;

-- comment on column nc_scorevalidator.validatortable is 'the table identifier for all data stored within this table.  in conjunction with a unique id creates a unique reference to all tuples within the database for tuple level access control.' ;

-- comment on column nc_scorevalidator.validatorid is 'the uniqueid column is one of the 5 core columns (tableid, uniqueid, owner, modtime, moduser) in the database  taken together with the tableid column these two columns specify a global unique object/tuple identifier within the database.  this unique identifying pair is critical for the extended tuple interface, database access controls and time travel. the uniqueid also servers as the principal unique identifier within each core table.' ;

