\i nc_dataObjectType.sql;
\i Tables/nc_jobs.sql;
\i Tables/nc_site.sql;
\i Tables/nc_dataArchive.sql;
\i Tables/nc_humanSubjectAlter.sql;

-- foreign keys


alter table nc_humansubject add constraint refnc_site_humansubject
    foreign key (siteid)
    references nc_site(uniqueid)
;

-- 
-- table: nc_jobs
--
alter table nc_jobs add constraint refnc_tableid2874
    foreign key (tableid)
    references nc_tableid(tableid)
;

alter table nc_jobs add constraint refnc_databaseuser3054
    foreign key (owner)
    references nc_databaseuser(uniqueid)
;

alter table nc_jobs add constraint refnc_databaseuser3064
    foreign key (moduser)
    references nc_databaseuser(uniqueid)
;

-- table: nc_dataobjecttype
alter table nc_dataobjecttype add constraint refnc_tableid2873
    foreign key (tableid)
    references nc_tableid(tableid)
;

alter table nc_dataobjecttype add constraint refnc_databaseuser3053
    foreign key (owner)
    references nc_databaseuser(uniqueid)
;

alter table nc_dataobjecttype add constraint refnc_databaseuser3063
    foreign key (moduser)
    references nc_databaseuser(uniqueid)
;

-- table: nc_dataobject 
--

alter table nc_dataobject add constraint refnc_researchdata2001 
    foreign key (dataid)
    references nc_researchdata(uniqueid)
;

alter table nc_dataobject add constraint refnc_tableid2871 
    foreign key (tableid)
    references nc_tableid(tableid)
;

alter table nc_dataobject add constraint refnc_databaseuser3051 
    foreign key (owner)
    references nc_databaseuser(uniqueid)
;

alter table nc_dataobject add constraint refnc_databaseuser3061 
    foreign key (moduser)
    references nc_databaseuser(uniqueid)
;

-- (10/5/2007)
alter table nc_dataobject add constraint refnc_dataobjecttype3062
    foreign key (objecttype)
    references nc_dataobjecttype(objecttype)
;

-- 
-- table: nc_dataarchive (10/5/2007)
--

alter table nc_dataarchive add constraint refnc_tableid2875
    foreign key (tableid)
    references nc_tableid(tableid)
;

alter table nc_dataarchive add constraint refnc_databaseuser3055
    foreign key (owner)
    references nc_databaseuser(uniqueid)
;

alter table nc_dataarchive add constraint refnc_databaseuser3065
    foreign key (moduser)
    references nc_databaseuser(uniqueid)
;


-- 
-- table: nc_site 
--
alter table nc_site add constraint refnc_tableid2872
    foreign key (tableid)
    references nc_tableid(tableid)
;

alter table nc_site add constraint refnc_databaseuser3052
    foreign key (owner)
    references nc_databaseuser(uniqueid)
;

alter table nc_site add constraint refnc_databaseuser3062
    foreign key (moduser)
    references nc_databaseuser(uniqueid)
;

-- end of foreign key updates


\i modify_static_data_10_5_2007.sql
-- IMPORTANT: the data entered by modify_static_10_5_2007 function
-- is process specific and needs to be customized BEFORE usage
-- the site_name (second argument) must be the name of the site setting up
-- the postgres database
--
-- The FBIRN site names are
-- Duke
-- BWH
-- MGH
-- UCLA
-- UCI
-- UNM
-- Iowa
-- UMN
-- Yale
-- UCSD
select modify_static_data_10_5_2007('postgres', 'UCSD');
